%%  ACX YAW RATE SISO LQ CONTROL
%
%   Authors: Konstantinos Alexis (konstantinos.alexis@mavt.ethz.ch)

%%  

Ay = zeros(2,2);
Ay(2,2) = r_miso_ss.A(1);
Ay(1,2) = 1;
By = zeros(2,1);
By(2,1) = r_miso_ss.B(1,1);

yaw_simo_ss = ss(Ay,By,eye(2,2),zeros(2,1));
yaw_siso_ss = ss(Ay,By,eye(1,2),zeros(1,1));
yaw_siso_tf = tf(yaw_siso_ss)*((swash_cfg.MAX_HEIGHT - swash_cfg.MIN_HEIGHT)/2);
yaw_siso_ss = ss(yaw_siso_tf);

clc;
SYS = yaw_simo_ss;

[N_x,N_u] = size(SYS.B);
[N_y,~] = size(SYS.C);
SYS.InputDelay = zeros(1,N_u);

% Q = (10^2)*eye(N_x+N_y);  Q(11,11) = 10^9; Q(12,12) = 10^10; Q(13,13) = Q(11,11); Q(14,14) = Q(12,12); % lqi
% %Q = 10^6*eye(N_y); % for lqry
% %Q = (10^6)*eye(N_x);  % lqr
% R = (10^4)*eye(N_u);
% %QI = eye(N_y);

Q = (10^5)*eye(N_x+N_y);  % Q(11,11) = 10^8.9; Q(12,12) = 10^10.8; Q(13,13) = Q(11,11); Q(14,14) = Q(12,12); % lqi
%Q = 10^6*eye(N_y); % for lqry
%Q = (10^6)*eye(N_x);  % lqr
R = (10^2)*eye(N_u);
%QI = eye(N_y);
    
% Q = (10^5)*eye(N_x+N_y);  Q(11,11) = 10^15 ; Q(12,12) = 10^5; Q(13,13) = Q(11,11); Q(14,14) = Q(12,12); % lqi
% %Q = 10^6*eye(N_y); % for lqry
% %Q = (10^6)*eye(N_x);  % lqr
% R = (10^8)*eye(N_u);
% %QI = eye(N_y);

% Q = (10^3)*eye(N_x+N_y);  Q(11,11) = 10^11 ; Q(12,12) = 10^5; Q(13,13) = Q(11,11); Q(14,14) = Q(12,12); % lqi
% %Q = 10^6*eye(N_y); % for lqry
% %Q = (10^6)*eye(N_x);  % lqr
% R = (10^4)*eye(N_u);
% %QI = eye(N_y);

% STEP 1: COMPUTE THE OPTIMAL (KALMAN) STATE ESTIMATOR:

% which outputs do we know (only the first four actually...)
sensors = [1 2];
% which input are deterministic (lets assume that everything is
% stochastic)
known = [1 2];

Qn = 1*eye(N_u -length(known));  %Qn =[];
%Qn = 1000*eye(N_u);  known = [];%Qn =[];
Rn =1*eye(N_y); 
Nn = [];
%[kest,L,P] = kalman(SYS,Qn,Rn,Nn,sensors,known);

% STEP 2: COMPUTE THE OPTIMAL CONTROL GAIN

[Kyaw_simo,Syaw_simo,eyaw_simo] = lqi(SYS,Q,R);
%[K,S,e] = lqry(MIMO_PQ_SS,Q,R);
%[K,S,e] = lqr(MIMO_PQ_SS,Q,R);

% FINAL: COMPUTE LQG CONTROLLER
%LQG_CON_SS = lqgreg(kest,K); % regulation
%LQG_CON_SS = lqgtrack(kest,K); % tracking 
%LQG_CON_SS = lqg(kest,K); % regulation