function [] = ACX_SIM_SetupPlots( fig_handles )
%##########################################################################
% [] = ACX_SetupPlots()
%
% Open and arrange all gui windows.
%
%--------------------------------------------------------------------------
% Author: Christoph Huerzeler (ASL-ETHZ)
% Date: 2011
% Email: christoph.huerzeler@mavt.ethz.ch
%##########################################################################
%% Import java awt
import java.awt.*;
%DO_NOTHING_ON_CLOSE = 0;

%% Get access to matlab desktop
desktop     = com.mathworks.mde.desk.MLDesktop.getInstance;
screen_size = get( 0, 'ScreenSize' );
winbnds     = [0 40 screen_size(3) screen_size(4)];


%% Create the plot windows
dock_name  = 'ACX Plot Dock';
max_bounds = java.awt.Rectangle( winbnds(1), ...
                                 winbnds(2), ...
                                 winbnds(3), ...
                                 winbnds(4) );
set( fig_handles, 'Visible', 'on' );
sensor_dock = ACX_SIM_setFigDockGroup( fig_handles, dock_name );
desktop.setGroupDocked( dock_name, false );
%desktop.setGroupMinimized( dock_name, true );
set( fig_handles, 'WindowStyle', 'docked' );
plotbrowser( 'off' ); 



%sensorwindow = sensor_dock.getTopLevelAncestor();
%sensorwindow.setMaximizedBounds( max_bounds );
%sensorwindow.setMinimized( 1 );
%sensorwindow.setMaximized( 1 );


%% --- end of file