/* Include files */

#include "blascompat32.h"
#include "ACX_Simulator_sfun.h"
#include "c33_ACX_Simulator.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ACX_Simulator_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c33_debug_family_names[19] = { "K_P", "K_I", "K_D", "Psat",
  "Isat", "Dsat", "PIDsat", "Pprod", "Iprod", "Dprod", "nargin", "nargout",
  "e_pos", "e_int", "e_vel", "Gains", "Sat", "CA", "SAT_FLAG" };

/* Function Declarations */
static void initialize_c33_ACX_Simulator(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initialize_params_c33_ACX_Simulator
  (SFc33_ACX_SimulatorInstanceStruct *chartInstance);
static void enable_c33_ACX_Simulator(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance);
static void disable_c33_ACX_Simulator(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance);
static void c33_update_debugger_state_c33_ACX_Simulator
  (SFc33_ACX_SimulatorInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c33_ACX_Simulator
  (SFc33_ACX_SimulatorInstanceStruct *chartInstance);
static void set_sim_state_c33_ACX_Simulator(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c33_st);
static void finalize_c33_ACX_Simulator(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance);
static void sf_c33_ACX_Simulator(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initSimStructsc33_ACX_Simulator(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c33_machineNumber, uint32_T
  c33_chartNumber);
static const mxArray *c33_sf_marshallOut(void *chartInstanceVoid, void
  *c33_inData);
static real_T c33_emlrt_marshallIn(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c33_SAT_FLAG, const char_T *c33_identifier);
static real_T c33_b_emlrt_marshallIn(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c33_u, const emlrtMsgIdentifier *c33_parentId);
static void c33_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c33_mxArrayInData, const char_T *c33_varName, void *c33_outData);
static const mxArray *c33_b_sf_marshallOut(void *chartInstanceVoid, void
  *c33_inData);
static const mxArray *c33_c_sf_marshallOut(void *chartInstanceVoid, void
  *c33_inData);
static real_T c33_max(SFc33_ACX_SimulatorInstanceStruct *chartInstance, real_T
                      c33_varargin_1, real_T c33_varargin_2);
static void c33_eml_scalar_eg(SFc33_ACX_SimulatorInstanceStruct *chartInstance);
static real_T c33_min(SFc33_ACX_SimulatorInstanceStruct *chartInstance, real_T
                      c33_varargin_1, real_T c33_varargin_2);
static const mxArray *c33_d_sf_marshallOut(void *chartInstanceVoid, void
  *c33_inData);
static int32_T c33_c_emlrt_marshallIn(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c33_u, const emlrtMsgIdentifier *c33_parentId);
static void c33_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c33_mxArrayInData, const char_T *c33_varName, void *c33_outData);
static uint8_T c33_d_emlrt_marshallIn(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c33_b_is_active_c33_ACX_Simulator, const char_T
  *c33_identifier);
static uint8_T c33_e_emlrt_marshallIn(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c33_u, const emlrtMsgIdentifier *c33_parentId);
static void init_dsm_address_info(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c33_ACX_Simulator(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  chartInstance->c33_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c33_is_active_c33_ACX_Simulator = 0U;
}

static void initialize_params_c33_ACX_Simulator
  (SFc33_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static void enable_c33_ACX_Simulator(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c33_ACX_Simulator(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c33_update_debugger_state_c33_ACX_Simulator
  (SFc33_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c33_ACX_Simulator
  (SFc33_ACX_SimulatorInstanceStruct *chartInstance)
{
  const mxArray *c33_st;
  const mxArray *c33_y = NULL;
  real_T c33_hoistedGlobal;
  real_T c33_u;
  const mxArray *c33_b_y = NULL;
  real_T c33_b_hoistedGlobal;
  real_T c33_b_u;
  const mxArray *c33_c_y = NULL;
  uint8_T c33_c_hoistedGlobal;
  uint8_T c33_c_u;
  const mxArray *c33_d_y = NULL;
  real_T *c33_CA;
  real_T *c33_SAT_FLAG;
  c33_SAT_FLAG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c33_CA = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c33_st = NULL;
  c33_st = NULL;
  c33_y = NULL;
  sf_mex_assign(&c33_y, sf_mex_createcellarray(3));
  c33_hoistedGlobal = *c33_CA;
  c33_u = c33_hoistedGlobal;
  c33_b_y = NULL;
  sf_mex_assign(&c33_b_y, sf_mex_create("y", &c33_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c33_y, 0, c33_b_y);
  c33_b_hoistedGlobal = *c33_SAT_FLAG;
  c33_b_u = c33_b_hoistedGlobal;
  c33_c_y = NULL;
  sf_mex_assign(&c33_c_y, sf_mex_create("y", &c33_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c33_y, 1, c33_c_y);
  c33_c_hoistedGlobal = chartInstance->c33_is_active_c33_ACX_Simulator;
  c33_c_u = c33_c_hoistedGlobal;
  c33_d_y = NULL;
  sf_mex_assign(&c33_d_y, sf_mex_create("y", &c33_c_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c33_y, 2, c33_d_y);
  sf_mex_assign(&c33_st, c33_y);
  return c33_st;
}

static void set_sim_state_c33_ACX_Simulator(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c33_st)
{
  const mxArray *c33_u;
  real_T *c33_CA;
  real_T *c33_SAT_FLAG;
  c33_SAT_FLAG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c33_CA = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c33_doneDoubleBufferReInit = TRUE;
  c33_u = sf_mex_dup(c33_st);
  *c33_CA = c33_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c33_u,
    0)), "CA");
  *c33_SAT_FLAG = c33_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c33_u, 1)), "SAT_FLAG");
  chartInstance->c33_is_active_c33_ACX_Simulator = c33_d_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c33_u, 2)),
     "is_active_c33_ACX_Simulator");
  sf_mex_destroy(&c33_u);
  c33_update_debugger_state_c33_ACX_Simulator(chartInstance);
  sf_mex_destroy(&c33_st);
}

static void finalize_c33_ACX_Simulator(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void sf_c33_ACX_Simulator(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  int32_T c33_i0;
  int32_T c33_i1;
  real_T c33_hoistedGlobal;
  real_T c33_b_hoistedGlobal;
  real_T c33_c_hoistedGlobal;
  real_T c33_e_pos;
  real_T c33_e_int;
  real_T c33_e_vel;
  int32_T c33_i2;
  real_T c33_Gains[3];
  int32_T c33_i3;
  real_T c33_Sat[4];
  uint32_T c33_debug_family_var_map[19];
  real_T c33_K_P;
  real_T c33_K_I;
  real_T c33_K_D;
  real_T c33_Psat;
  real_T c33_Isat;
  real_T c33_Dsat;
  real_T c33_PIDsat;
  real_T c33_Pprod;
  real_T c33_Iprod;
  real_T c33_Dprod;
  real_T c33_nargin = 5.0;
  real_T c33_nargout = 2.0;
  real_T c33_CA;
  real_T c33_SAT_FLAG;
  real_T c33_a;
  real_T c33_b;
  real_T c33_b_a;
  real_T c33_b_b;
  real_T c33_c_a;
  real_T c33_c_b;
  real_T c33_x;
  real_T c33_b_x;
  real_T c33_y;
  real_T *c33_b_e_pos;
  real_T *c33_b_CA;
  real_T *c33_b_e_int;
  real_T *c33_b_e_vel;
  real_T *c33_b_SAT_FLAG;
  real_T (*c33_b_Sat)[4];
  real_T (*c33_b_Gains)[3];
  c33_b_SAT_FLAG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c33_b_Sat = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 4);
  c33_b_Gains = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
  c33_b_e_vel = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c33_b_e_int = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c33_b_CA = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c33_b_e_pos = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 32U, chartInstance->c33_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c33_b_e_pos, 0U);
  _SFD_DATA_RANGE_CHECK(*c33_b_CA, 1U);
  _SFD_DATA_RANGE_CHECK(*c33_b_e_int, 2U);
  _SFD_DATA_RANGE_CHECK(*c33_b_e_vel, 3U);
  for (c33_i0 = 0; c33_i0 < 3; c33_i0++) {
    _SFD_DATA_RANGE_CHECK((*c33_b_Gains)[c33_i0], 4U);
  }

  for (c33_i1 = 0; c33_i1 < 4; c33_i1++) {
    _SFD_DATA_RANGE_CHECK((*c33_b_Sat)[c33_i1], 5U);
  }

  _SFD_DATA_RANGE_CHECK(*c33_b_SAT_FLAG, 6U);
  chartInstance->c33_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 32U, chartInstance->c33_sfEvent);
  c33_hoistedGlobal = *c33_b_e_pos;
  c33_b_hoistedGlobal = *c33_b_e_int;
  c33_c_hoistedGlobal = *c33_b_e_vel;
  c33_e_pos = c33_hoistedGlobal;
  c33_e_int = c33_b_hoistedGlobal;
  c33_e_vel = c33_c_hoistedGlobal;
  for (c33_i2 = 0; c33_i2 < 3; c33_i2++) {
    c33_Gains[c33_i2] = (*c33_b_Gains)[c33_i2];
  }

  for (c33_i3 = 0; c33_i3 < 4; c33_i3++) {
    c33_Sat[c33_i3] = (*c33_b_Sat)[c33_i3];
  }

  sf_debug_symbol_scope_push_eml(0U, 19U, 19U, c33_debug_family_names,
    c33_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c33_K_P, 0U, c33_sf_marshallOut,
    c33_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c33_K_I, 1U, c33_sf_marshallOut,
    c33_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c33_K_D, 2U, c33_sf_marshallOut,
    c33_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c33_Psat, 3U, c33_sf_marshallOut,
    c33_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c33_Isat, 4U, c33_sf_marshallOut,
    c33_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c33_Dsat, 5U, c33_sf_marshallOut,
    c33_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c33_PIDsat, 6U, c33_sf_marshallOut,
    c33_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c33_Pprod, 7U, c33_sf_marshallOut,
    c33_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c33_Iprod, 8U, c33_sf_marshallOut,
    c33_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c33_Dprod, 9U, c33_sf_marshallOut,
    c33_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c33_nargin, 10U, c33_sf_marshallOut,
    c33_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c33_nargout, 11U, c33_sf_marshallOut,
    c33_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c33_e_pos, 12U, c33_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c33_e_int, 13U, c33_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c33_e_vel, 14U, c33_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c33_Gains, 15U, c33_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c33_Sat, 16U, c33_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c33_CA, 17U, c33_sf_marshallOut,
    c33_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c33_SAT_FLAG, 18U,
    c33_sf_marshallOut, c33_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 4);
  c33_K_P = c33_Gains[0];
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 5);
  c33_K_I = c33_Gains[1];
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 6);
  c33_K_D = c33_Gains[2];
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 7);
  c33_Psat = c33_Sat[0];
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 8);
  c33_Isat = c33_Sat[1];
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 9);
  c33_Dsat = c33_Sat[2];
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 10);
  c33_PIDsat = c33_Sat[3];
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 13);
  c33_a = c33_K_P;
  c33_b = c33_e_pos;
  c33_Pprod = c33_a * c33_b;
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 14);
  c33_b_a = c33_K_I;
  c33_b_b = c33_e_int;
  c33_Iprod = c33_b_a * c33_b_b;
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 15);
  c33_c_a = c33_K_D;
  c33_c_b = c33_e_vel;
  c33_Dprod = c33_c_a * c33_c_b;
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 17);
  c33_Pprod = c33_max(chartInstance, c33_Pprod, -c33_Psat);
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 18);
  c33_Pprod = c33_min(chartInstance, c33_Pprod, c33_Psat);
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 19);
  c33_Iprod = c33_max(chartInstance, c33_Iprod, -c33_Isat);
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 20);
  c33_Iprod = c33_min(chartInstance, c33_Iprod, c33_Isat);
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 21);
  c33_Dprod = c33_max(chartInstance, c33_Dprod, -c33_Dsat);
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 22);
  c33_Dprod = c33_min(chartInstance, c33_Dprod, c33_Dsat);
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 24);
  c33_CA = (c33_Pprod + c33_Iprod) + c33_Dprod;
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 25);
  c33_x = c33_CA;
  c33_b_x = c33_x;
  c33_y = muDoubleScalarAbs(c33_b_x);
  if (CV_EML_IF(0, 0, c33_y > c33_PIDsat)) {
    _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 26);
    c33_SAT_FLAG = 1.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 28);
    c33_SAT_FLAG = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 30);
  c33_CA = c33_max(chartInstance, c33_CA, -c33_PIDsat);
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, 31);
  c33_CA = c33_min(chartInstance, c33_CA, c33_PIDsat);
  _SFD_EML_CALL(0U, chartInstance->c33_sfEvent, -31);
  sf_debug_symbol_scope_pop();
  *c33_b_CA = c33_CA;
  *c33_b_SAT_FLAG = c33_SAT_FLAG;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 32U, chartInstance->c33_sfEvent);
  sf_debug_check_for_state_inconsistency(_ACX_SimulatorMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc33_ACX_Simulator(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c33_machineNumber, uint32_T
  c33_chartNumber)
{
}

static const mxArray *c33_sf_marshallOut(void *chartInstanceVoid, void
  *c33_inData)
{
  const mxArray *c33_mxArrayOutData = NULL;
  real_T c33_u;
  const mxArray *c33_y = NULL;
  SFc33_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc33_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c33_mxArrayOutData = NULL;
  c33_u = *(real_T *)c33_inData;
  c33_y = NULL;
  sf_mex_assign(&c33_y, sf_mex_create("y", &c33_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c33_mxArrayOutData, c33_y);
  return c33_mxArrayOutData;
}

static real_T c33_emlrt_marshallIn(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c33_SAT_FLAG, const char_T *c33_identifier)
{
  real_T c33_y;
  emlrtMsgIdentifier c33_thisId;
  c33_thisId.fIdentifier = c33_identifier;
  c33_thisId.fParent = NULL;
  c33_y = c33_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c33_SAT_FLAG),
    &c33_thisId);
  sf_mex_destroy(&c33_SAT_FLAG);
  return c33_y;
}

static real_T c33_b_emlrt_marshallIn(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c33_u, const emlrtMsgIdentifier *c33_parentId)
{
  real_T c33_y;
  real_T c33_d0;
  sf_mex_import(c33_parentId, sf_mex_dup(c33_u), &c33_d0, 1, 0, 0U, 0, 0U, 0);
  c33_y = c33_d0;
  sf_mex_destroy(&c33_u);
  return c33_y;
}

static void c33_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c33_mxArrayInData, const char_T *c33_varName, void *c33_outData)
{
  const mxArray *c33_SAT_FLAG;
  const char_T *c33_identifier;
  emlrtMsgIdentifier c33_thisId;
  real_T c33_y;
  SFc33_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc33_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c33_SAT_FLAG = sf_mex_dup(c33_mxArrayInData);
  c33_identifier = c33_varName;
  c33_thisId.fIdentifier = c33_identifier;
  c33_thisId.fParent = NULL;
  c33_y = c33_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c33_SAT_FLAG),
    &c33_thisId);
  sf_mex_destroy(&c33_SAT_FLAG);
  *(real_T *)c33_outData = c33_y;
  sf_mex_destroy(&c33_mxArrayInData);
}

static const mxArray *c33_b_sf_marshallOut(void *chartInstanceVoid, void
  *c33_inData)
{
  const mxArray *c33_mxArrayOutData = NULL;
  int32_T c33_i4;
  real_T c33_b_inData[4];
  int32_T c33_i5;
  real_T c33_u[4];
  const mxArray *c33_y = NULL;
  SFc33_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc33_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c33_mxArrayOutData = NULL;
  for (c33_i4 = 0; c33_i4 < 4; c33_i4++) {
    c33_b_inData[c33_i4] = (*(real_T (*)[4])c33_inData)[c33_i4];
  }

  for (c33_i5 = 0; c33_i5 < 4; c33_i5++) {
    c33_u[c33_i5] = c33_b_inData[c33_i5];
  }

  c33_y = NULL;
  sf_mex_assign(&c33_y, sf_mex_create("y", c33_u, 0, 0U, 1U, 0U, 1, 4));
  sf_mex_assign(&c33_mxArrayOutData, c33_y);
  return c33_mxArrayOutData;
}

static const mxArray *c33_c_sf_marshallOut(void *chartInstanceVoid, void
  *c33_inData)
{
  const mxArray *c33_mxArrayOutData = NULL;
  int32_T c33_i6;
  real_T c33_b_inData[3];
  int32_T c33_i7;
  real_T c33_u[3];
  const mxArray *c33_y = NULL;
  SFc33_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc33_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c33_mxArrayOutData = NULL;
  for (c33_i6 = 0; c33_i6 < 3; c33_i6++) {
    c33_b_inData[c33_i6] = (*(real_T (*)[3])c33_inData)[c33_i6];
  }

  for (c33_i7 = 0; c33_i7 < 3; c33_i7++) {
    c33_u[c33_i7] = c33_b_inData[c33_i7];
  }

  c33_y = NULL;
  sf_mex_assign(&c33_y, sf_mex_create("y", c33_u, 0, 0U, 1U, 0U, 1, 3));
  sf_mex_assign(&c33_mxArrayOutData, c33_y);
  return c33_mxArrayOutData;
}

const mxArray *sf_c33_ACX_Simulator_get_eml_resolved_functions_info(void)
{
  const mxArray *c33_nameCaptureInfo;
  c33_ResolvedFunctionInfo c33_info[9];
  c33_ResolvedFunctionInfo (*c33_b_info)[9];
  const mxArray *c33_m0 = NULL;
  int32_T c33_i8;
  c33_ResolvedFunctionInfo *c33_r0;
  c33_nameCaptureInfo = NULL;
  c33_nameCaptureInfo = NULL;
  c33_b_info = (c33_ResolvedFunctionInfo (*)[9])c33_info;
  (*c33_b_info)[0].context = "";
  (*c33_b_info)[0].name = "mtimes";
  (*c33_b_info)[0].dominantType = "double";
  (*c33_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c33_b_info)[0].fileTimeLo = 1289519692U;
  (*c33_b_info)[0].fileTimeHi = 0U;
  (*c33_b_info)[0].mFileTimeLo = 0U;
  (*c33_b_info)[0].mFileTimeHi = 0U;
  (*c33_b_info)[1].context = "";
  (*c33_b_info)[1].name = "max";
  (*c33_b_info)[1].dominantType = "double";
  (*c33_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/max.m";
  (*c33_b_info)[1].fileTimeLo = 1286818694U;
  (*c33_b_info)[1].fileTimeHi = 0U;
  (*c33_b_info)[1].mFileTimeLo = 0U;
  (*c33_b_info)[1].mFileTimeHi = 0U;
  (*c33_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/max.m";
  (*c33_b_info)[2].name = "eml_min_or_max";
  (*c33_b_info)[2].dominantType = "char";
  (*c33_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  (*c33_b_info)[2].fileTimeLo = 1286818788U;
  (*c33_b_info)[2].fileTimeHi = 0U;
  (*c33_b_info)[2].mFileTimeLo = 0U;
  (*c33_b_info)[2].mFileTimeHi = 0U;
  (*c33_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  (*c33_b_info)[3].name = "eml_scalar_eg";
  (*c33_b_info)[3].dominantType = "double";
  (*c33_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  (*c33_b_info)[3].fileTimeLo = 1286818796U;
  (*c33_b_info)[3].fileTimeHi = 0U;
  (*c33_b_info)[3].mFileTimeLo = 0U;
  (*c33_b_info)[3].mFileTimeHi = 0U;
  (*c33_b_info)[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  (*c33_b_info)[4].name = "eml_scalexp_alloc";
  (*c33_b_info)[4].dominantType = "double";
  (*c33_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  (*c33_b_info)[4].fileTimeLo = 1286818796U;
  (*c33_b_info)[4].fileTimeHi = 0U;
  (*c33_b_info)[4].mFileTimeLo = 0U;
  (*c33_b_info)[4].mFileTimeHi = 0U;
  (*c33_b_info)[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  (*c33_b_info)[5].name = "eml_index_class";
  (*c33_b_info)[5].dominantType = "";
  (*c33_b_info)[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  (*c33_b_info)[5].fileTimeLo = 1286818778U;
  (*c33_b_info)[5].fileTimeHi = 0U;
  (*c33_b_info)[5].mFileTimeLo = 0U;
  (*c33_b_info)[5].mFileTimeHi = 0U;
  (*c33_b_info)[6].context = "";
  (*c33_b_info)[6].name = "min";
  (*c33_b_info)[6].dominantType = "double";
  (*c33_b_info)[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  (*c33_b_info)[6].fileTimeLo = 1286818696U;
  (*c33_b_info)[6].fileTimeHi = 0U;
  (*c33_b_info)[6].mFileTimeLo = 0U;
  (*c33_b_info)[6].mFileTimeHi = 0U;
  (*c33_b_info)[7].context = "";
  (*c33_b_info)[7].name = "abs";
  (*c33_b_info)[7].dominantType = "double";
  (*c33_b_info)[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c33_b_info)[7].fileTimeLo = 1286818694U;
  (*c33_b_info)[7].fileTimeHi = 0U;
  (*c33_b_info)[7].mFileTimeLo = 0U;
  (*c33_b_info)[7].mFileTimeHi = 0U;
  (*c33_b_info)[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c33_b_info)[8].name = "eml_scalar_abs";
  (*c33_b_info)[8].dominantType = "double";
  (*c33_b_info)[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  (*c33_b_info)[8].fileTimeLo = 1286818712U;
  (*c33_b_info)[8].fileTimeHi = 0U;
  (*c33_b_info)[8].mFileTimeLo = 0U;
  (*c33_b_info)[8].mFileTimeHi = 0U;
  sf_mex_assign(&c33_m0, sf_mex_createstruct("nameCaptureInfo", 1, 9));
  for (c33_i8 = 0; c33_i8 < 9; c33_i8++) {
    c33_r0 = &c33_info[c33_i8];
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo", c33_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c33_r0->context)), "context", "nameCaptureInfo",
                    c33_i8);
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo", c33_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c33_r0->name)), "name", "nameCaptureInfo", c33_i8);
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo",
      c33_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c33_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c33_i8);
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo", c33_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c33_r0->resolved)), "resolved",
                    "nameCaptureInfo", c33_i8);
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo", &c33_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c33_i8);
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo", &c33_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c33_i8);
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo",
      &c33_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c33_i8);
    sf_mex_addfield(c33_m0, sf_mex_create("nameCaptureInfo",
      &c33_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c33_i8);
  }

  sf_mex_assign(&c33_nameCaptureInfo, c33_m0);
  return c33_nameCaptureInfo;
}

static real_T c33_max(SFc33_ACX_SimulatorInstanceStruct *chartInstance, real_T
                      c33_varargin_1, real_T c33_varargin_2)
{
  real_T c33_x;
  real_T c33_y;
  real_T c33_b_x;
  real_T c33_b_y;
  real_T c33_xk;
  real_T c33_yk;
  real_T c33_c_x;
  real_T c33_c_y;
  c33_x = c33_varargin_1;
  c33_y = c33_varargin_2;
  c33_b_x = c33_x;
  c33_b_y = c33_y;
  c33_eml_scalar_eg(chartInstance);
  c33_xk = c33_b_x;
  c33_yk = c33_b_y;
  c33_c_x = c33_xk;
  c33_c_y = c33_yk;
  c33_eml_scalar_eg(chartInstance);
  return muDoubleScalarMax(c33_c_x, c33_c_y);
}

static void c33_eml_scalar_eg(SFc33_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static real_T c33_min(SFc33_ACX_SimulatorInstanceStruct *chartInstance, real_T
                      c33_varargin_1, real_T c33_varargin_2)
{
  real_T c33_x;
  real_T c33_y;
  real_T c33_b_x;
  real_T c33_b_y;
  real_T c33_xk;
  real_T c33_yk;
  real_T c33_c_x;
  real_T c33_c_y;
  c33_x = c33_varargin_1;
  c33_y = c33_varargin_2;
  c33_b_x = c33_x;
  c33_b_y = c33_y;
  c33_eml_scalar_eg(chartInstance);
  c33_xk = c33_b_x;
  c33_yk = c33_b_y;
  c33_c_x = c33_xk;
  c33_c_y = c33_yk;
  c33_eml_scalar_eg(chartInstance);
  return muDoubleScalarMin(c33_c_x, c33_c_y);
}

static const mxArray *c33_d_sf_marshallOut(void *chartInstanceVoid, void
  *c33_inData)
{
  const mxArray *c33_mxArrayOutData = NULL;
  int32_T c33_u;
  const mxArray *c33_y = NULL;
  SFc33_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc33_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c33_mxArrayOutData = NULL;
  c33_u = *(int32_T *)c33_inData;
  c33_y = NULL;
  sf_mex_assign(&c33_y, sf_mex_create("y", &c33_u, 6, 0U, 0U, 0U, 0));
  sf_mex_assign(&c33_mxArrayOutData, c33_y);
  return c33_mxArrayOutData;
}

static int32_T c33_c_emlrt_marshallIn(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c33_u, const emlrtMsgIdentifier *c33_parentId)
{
  int32_T c33_y;
  int32_T c33_i9;
  sf_mex_import(c33_parentId, sf_mex_dup(c33_u), &c33_i9, 1, 6, 0U, 0, 0U, 0);
  c33_y = c33_i9;
  sf_mex_destroy(&c33_u);
  return c33_y;
}

static void c33_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c33_mxArrayInData, const char_T *c33_varName, void *c33_outData)
{
  const mxArray *c33_b_sfEvent;
  const char_T *c33_identifier;
  emlrtMsgIdentifier c33_thisId;
  int32_T c33_y;
  SFc33_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc33_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c33_b_sfEvent = sf_mex_dup(c33_mxArrayInData);
  c33_identifier = c33_varName;
  c33_thisId.fIdentifier = c33_identifier;
  c33_thisId.fParent = NULL;
  c33_y = c33_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c33_b_sfEvent),
    &c33_thisId);
  sf_mex_destroy(&c33_b_sfEvent);
  *(int32_T *)c33_outData = c33_y;
  sf_mex_destroy(&c33_mxArrayInData);
}

static uint8_T c33_d_emlrt_marshallIn(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c33_b_is_active_c33_ACX_Simulator, const char_T
  *c33_identifier)
{
  uint8_T c33_y;
  emlrtMsgIdentifier c33_thisId;
  c33_thisId.fIdentifier = c33_identifier;
  c33_thisId.fParent = NULL;
  c33_y = c33_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c33_b_is_active_c33_ACX_Simulator), &c33_thisId);
  sf_mex_destroy(&c33_b_is_active_c33_ACX_Simulator);
  return c33_y;
}

static uint8_T c33_e_emlrt_marshallIn(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c33_u, const emlrtMsgIdentifier *c33_parentId)
{
  uint8_T c33_y;
  uint8_T c33_u0;
  sf_mex_import(c33_parentId, sf_mex_dup(c33_u), &c33_u0, 1, 3, 0U, 0, 0U, 0);
  c33_y = c33_u0;
  sf_mex_destroy(&c33_u);
  return c33_y;
}

static void init_dsm_address_info(SFc33_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c33_ACX_Simulator_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3264206008U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(4087544408U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(315411654U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1336891903U);
}

mxArray *sf_c33_ACX_Simulator_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1787983721U);
    pr[1] = (double)(2665147289U);
    pr[2] = (double)(3679744148U);
    pr[3] = (double)(2136607403U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c33_ACX_Simulator(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[5],T\"CA\",},{M[1],M[10],T\"SAT_FLAG\",},{M[8],M[0],T\"is_active_c33_ACX_Simulator\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c33_ACX_Simulator_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc33_ACX_SimulatorInstanceStruct *chartInstance;
    chartInstance = (SFc33_ACX_SimulatorInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ACX_SimulatorMachineNumber_,
           33,
           1,
           1,
           7,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_ACX_SimulatorMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"e_pos");
          _SFD_SET_DATA_PROPS(1,2,0,1,"CA");
          _SFD_SET_DATA_PROPS(2,1,1,0,"e_int");
          _SFD_SET_DATA_PROPS(3,1,1,0,"e_vel");
          _SFD_SET_DATA_PROPS(4,1,1,0,"Gains");
          _SFD_SET_DATA_PROPS(5,1,1,0,"Sat");
          _SFD_SET_DATA_PROPS(6,2,0,1,"SAT_FLAG");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,537);
        _SFD_CV_INIT_EML_IF(0,0,426,444,463,489);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c33_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c33_sf_marshallOut,(MexInFcnForType)c33_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c33_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c33_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c33_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c33_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c33_sf_marshallOut,(MexInFcnForType)c33_sf_marshallIn);

        {
          real_T *c33_e_pos;
          real_T *c33_CA;
          real_T *c33_e_int;
          real_T *c33_e_vel;
          real_T *c33_SAT_FLAG;
          real_T (*c33_Gains)[3];
          real_T (*c33_Sat)[4];
          c33_SAT_FLAG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c33_Sat = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 4);
          c33_Gains = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
          c33_e_vel = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c33_e_int = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c33_CA = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c33_e_pos = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c33_e_pos);
          _SFD_SET_DATA_VALUE_PTR(1U, c33_CA);
          _SFD_SET_DATA_VALUE_PTR(2U, c33_e_int);
          _SFD_SET_DATA_VALUE_PTR(3U, c33_e_vel);
          _SFD_SET_DATA_VALUE_PTR(4U, *c33_Gains);
          _SFD_SET_DATA_VALUE_PTR(5U, *c33_Sat);
          _SFD_SET_DATA_VALUE_PTR(6U, c33_SAT_FLAG);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ACX_SimulatorMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c33_ACX_Simulator(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc33_ACX_SimulatorInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c33_ACX_Simulator((SFc33_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
  initialize_c33_ACX_Simulator((SFc33_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c33_ACX_Simulator(void *chartInstanceVar)
{
  enable_c33_ACX_Simulator((SFc33_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c33_ACX_Simulator(void *chartInstanceVar)
{
  disable_c33_ACX_Simulator((SFc33_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c33_ACX_Simulator(void *chartInstanceVar)
{
  sf_c33_ACX_Simulator((SFc33_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c33_ACX_Simulator(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c33_ACX_Simulator
    ((SFc33_ACX_SimulatorInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c33_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c33_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c33_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c33_ACX_Simulator((SFc33_ACX_SimulatorInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c33_ACX_Simulator(SimStruct* S)
{
  return sf_internal_get_sim_state_c33_ACX_Simulator(S);
}

static void sf_opaque_set_sim_state_c33_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c33_ACX_Simulator(S, st);
}

static void sf_opaque_terminate_c33_ACX_Simulator(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc33_ACX_SimulatorInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c33_ACX_Simulator((SFc33_ACX_SimulatorInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc33_ACX_Simulator((SFc33_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c33_ACX_Simulator(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c33_ACX_Simulator((SFc33_ACX_SimulatorInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c33_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,"ACX_Simulator","ACX_Simulator",33);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,"ACX_Simulator","ACX_Simulator",33,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,"ACX_Simulator",
      "ACX_Simulator",33,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"ACX_Simulator","ACX_Simulator",33,5);
      sf_mark_chart_reusable_outputs(S,"ACX_Simulator","ACX_Simulator",33,2);
    }

    sf_set_rtw_dwork_info(S,"ACX_Simulator","ACX_Simulator",33);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(4185360227U));
  ssSetChecksum1(S,(2406435408U));
  ssSetChecksum2(S,(1530214481U));
  ssSetChecksum3(S,(1470008200U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c33_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "ACX_Simulator", "ACX_Simulator",33);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c33_ACX_Simulator(SimStruct *S)
{
  SFc33_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc33_ACX_SimulatorInstanceStruct *)malloc(sizeof
    (SFc33_ACX_SimulatorInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc33_ACX_SimulatorInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c33_ACX_Simulator;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c33_ACX_Simulator;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c33_ACX_Simulator;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c33_ACX_Simulator;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c33_ACX_Simulator;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c33_ACX_Simulator;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c33_ACX_Simulator;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c33_ACX_Simulator;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c33_ACX_Simulator;
  chartInstance->chartInfo.mdlStart = mdlStart_c33_ACX_Simulator;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c33_ACX_Simulator;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c33_ACX_Simulator_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c33_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c33_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c33_ACX_Simulator(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c33_ACX_Simulator_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
