/* Include files */

#include "blascompat32.h"
#include "ACX_Simulator_sfun.h"
#include "c51_ACX_Simulator.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ACX_Simulator_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c51_debug_family_names[6] = { "nargin", "nargout", "x", "y",
  "heading", "xy_rot" };

/* Function Declarations */
static void initialize_c51_ACX_Simulator(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initialize_params_c51_ACX_Simulator
  (SFc51_ACX_SimulatorInstanceStruct *chartInstance);
static void enable_c51_ACX_Simulator(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance);
static void disable_c51_ACX_Simulator(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance);
static void c51_update_debugger_state_c51_ACX_Simulator
  (SFc51_ACX_SimulatorInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c51_ACX_Simulator
  (SFc51_ACX_SimulatorInstanceStruct *chartInstance);
static void set_sim_state_c51_ACX_Simulator(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c51_st);
static void finalize_c51_ACX_Simulator(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance);
static void sf_c51_ACX_Simulator(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initSimStructsc51_ACX_Simulator(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c51_machineNumber, uint32_T
  c51_chartNumber);
static const mxArray *c51_sf_marshallOut(void *chartInstanceVoid, void
  *c51_inData);
static void c51_emlrt_marshallIn(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c51_xy_rot, const char_T *c51_identifier,
  real_T c51_y[2]);
static void c51_b_emlrt_marshallIn(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c51_u, const emlrtMsgIdentifier *c51_parentId,
  real_T c51_y[2]);
static void c51_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c51_mxArrayInData, const char_T *c51_varName, void *c51_outData);
static const mxArray *c51_b_sf_marshallOut(void *chartInstanceVoid, void
  *c51_inData);
static real_T c51_c_emlrt_marshallIn(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c51_u, const emlrtMsgIdentifier *c51_parentId);
static void c51_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c51_mxArrayInData, const char_T *c51_varName, void *c51_outData);
static const mxArray *c51_c_sf_marshallOut(void *chartInstanceVoid, void
  *c51_inData);
static int32_T c51_d_emlrt_marshallIn(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c51_u, const emlrtMsgIdentifier *c51_parentId);
static void c51_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c51_mxArrayInData, const char_T *c51_varName, void *c51_outData);
static uint8_T c51_e_emlrt_marshallIn(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c51_b_is_active_c51_ACX_Simulator, const char_T
  *c51_identifier);
static uint8_T c51_f_emlrt_marshallIn(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c51_u, const emlrtMsgIdentifier *c51_parentId);
static void init_dsm_address_info(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c51_ACX_Simulator(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  chartInstance->c51_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c51_is_active_c51_ACX_Simulator = 0U;
}

static void initialize_params_c51_ACX_Simulator
  (SFc51_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static void enable_c51_ACX_Simulator(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c51_ACX_Simulator(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c51_update_debugger_state_c51_ACX_Simulator
  (SFc51_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c51_ACX_Simulator
  (SFc51_ACX_SimulatorInstanceStruct *chartInstance)
{
  const mxArray *c51_st;
  const mxArray *c51_y = NULL;
  int32_T c51_i0;
  real_T c51_u[2];
  const mxArray *c51_b_y = NULL;
  uint8_T c51_hoistedGlobal;
  uint8_T c51_b_u;
  const mxArray *c51_c_y = NULL;
  real_T (*c51_xy_rot)[2];
  c51_xy_rot = (real_T (*)[2])ssGetOutputPortSignal(chartInstance->S, 1);
  c51_st = NULL;
  c51_st = NULL;
  c51_y = NULL;
  sf_mex_assign(&c51_y, sf_mex_createcellarray(2));
  for (c51_i0 = 0; c51_i0 < 2; c51_i0++) {
    c51_u[c51_i0] = (*c51_xy_rot)[c51_i0];
  }

  c51_b_y = NULL;
  sf_mex_assign(&c51_b_y, sf_mex_create("y", c51_u, 0, 0U, 1U, 0U, 1, 2));
  sf_mex_setcell(c51_y, 0, c51_b_y);
  c51_hoistedGlobal = chartInstance->c51_is_active_c51_ACX_Simulator;
  c51_b_u = c51_hoistedGlobal;
  c51_c_y = NULL;
  sf_mex_assign(&c51_c_y, sf_mex_create("y", &c51_b_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c51_y, 1, c51_c_y);
  sf_mex_assign(&c51_st, c51_y);
  return c51_st;
}

static void set_sim_state_c51_ACX_Simulator(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c51_st)
{
  const mxArray *c51_u;
  real_T c51_dv0[2];
  int32_T c51_i1;
  real_T (*c51_xy_rot)[2];
  c51_xy_rot = (real_T (*)[2])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c51_doneDoubleBufferReInit = TRUE;
  c51_u = sf_mex_dup(c51_st);
  c51_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c51_u, 0)),
                       "xy_rot", c51_dv0);
  for (c51_i1 = 0; c51_i1 < 2; c51_i1++) {
    (*c51_xy_rot)[c51_i1] = c51_dv0[c51_i1];
  }

  chartInstance->c51_is_active_c51_ACX_Simulator = c51_e_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c51_u, 1)),
     "is_active_c51_ACX_Simulator");
  sf_mex_destroy(&c51_u);
  c51_update_debugger_state_c51_ACX_Simulator(chartInstance);
  sf_mex_destroy(&c51_st);
}

static void finalize_c51_ACX_Simulator(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void sf_c51_ACX_Simulator(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  int32_T c51_i2;
  real_T c51_hoistedGlobal;
  real_T c51_b_hoistedGlobal;
  real_T c51_c_hoistedGlobal;
  real_T c51_x;
  real_T c51_y;
  real_T c51_heading;
  uint32_T c51_debug_family_var_map[6];
  real_T c51_nargin = 3.0;
  real_T c51_nargout = 1.0;
  real_T c51_xy_rot[2];
  int32_T c51_i3;
  real_T c51_b_x;
  real_T c51_c_x;
  real_T c51_a;
  real_T c51_b;
  real_T c51_b_y;
  real_T c51_d_x;
  real_T c51_e_x;
  real_T c51_b_a;
  real_T c51_b_b;
  real_T c51_c_y;
  real_T c51_f_x;
  real_T c51_g_x;
  real_T c51_c_a;
  real_T c51_c_b;
  real_T c51_d_y;
  real_T c51_h_x;
  real_T c51_i_x;
  real_T c51_d_a;
  real_T c51_d_b;
  real_T c51_e_y;
  int32_T c51_i4;
  real_T *c51_j_x;
  real_T *c51_f_y;
  real_T *c51_b_heading;
  real_T (*c51_b_xy_rot)[2];
  c51_b_heading = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c51_b_xy_rot = (real_T (*)[2])ssGetOutputPortSignal(chartInstance->S, 1);
  c51_f_y = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c51_j_x = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 50U, chartInstance->c51_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c51_j_x, 0U);
  _SFD_DATA_RANGE_CHECK(*c51_f_y, 1U);
  for (c51_i2 = 0; c51_i2 < 2; c51_i2++) {
    _SFD_DATA_RANGE_CHECK((*c51_b_xy_rot)[c51_i2], 2U);
  }

  _SFD_DATA_RANGE_CHECK(*c51_b_heading, 3U);
  chartInstance->c51_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 50U, chartInstance->c51_sfEvent);
  c51_hoistedGlobal = *c51_j_x;
  c51_b_hoistedGlobal = *c51_f_y;
  c51_c_hoistedGlobal = *c51_b_heading;
  c51_x = c51_hoistedGlobal;
  c51_y = c51_b_hoistedGlobal;
  c51_heading = c51_c_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 6U, 6U, c51_debug_family_names,
    c51_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c51_nargin, 0U, c51_b_sf_marshallOut,
    c51_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c51_nargout, 1U,
    c51_b_sf_marshallOut, c51_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c51_x, 2U, c51_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c51_y, 3U, c51_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c51_heading, 4U, c51_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c51_xy_rot, 5U, c51_sf_marshallOut,
    c51_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c51_sfEvent, 7);
  for (c51_i3 = 0; c51_i3 < 2; c51_i3++) {
    c51_xy_rot[c51_i3] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c51_sfEvent, 8);
  c51_b_x = c51_heading;
  c51_c_x = c51_b_x;
  c51_c_x = muDoubleScalarCos(c51_c_x);
  c51_a = c51_x;
  c51_b = c51_c_x;
  c51_b_y = c51_a * c51_b;
  c51_d_x = c51_heading;
  c51_e_x = c51_d_x;
  c51_e_x = muDoubleScalarSin(c51_e_x);
  c51_b_a = c51_y;
  c51_b_b = c51_e_x;
  c51_c_y = c51_b_a * c51_b_b;
  c51_xy_rot[0] = c51_b_y + c51_c_y;
  _SFD_EML_CALL(0U, chartInstance->c51_sfEvent, 9);
  CV_EML_IF(0, 0, c51_xy_rot[0] >= 0.0);
  _SFD_EML_CALL(0U, chartInstance->c51_sfEvent, 12);
  c51_f_x = c51_heading;
  c51_g_x = c51_f_x;
  c51_g_x = muDoubleScalarSin(c51_g_x);
  c51_c_a = -c51_x;
  c51_c_b = c51_g_x;
  c51_d_y = c51_c_a * c51_c_b;
  c51_h_x = c51_heading;
  c51_i_x = c51_h_x;
  c51_i_x = muDoubleScalarCos(c51_i_x);
  c51_d_a = c51_y;
  c51_d_b = c51_i_x;
  c51_e_y = c51_d_a * c51_d_b;
  c51_xy_rot[1] = c51_d_y + c51_e_y;
  _SFD_EML_CALL(0U, chartInstance->c51_sfEvent, -12);
  sf_debug_symbol_scope_pop();
  for (c51_i4 = 0; c51_i4 < 2; c51_i4++) {
    (*c51_b_xy_rot)[c51_i4] = c51_xy_rot[c51_i4];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 50U, chartInstance->c51_sfEvent);
  sf_debug_check_for_state_inconsistency(_ACX_SimulatorMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc51_ACX_Simulator(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c51_machineNumber, uint32_T
  c51_chartNumber)
{
}

static const mxArray *c51_sf_marshallOut(void *chartInstanceVoid, void
  *c51_inData)
{
  const mxArray *c51_mxArrayOutData = NULL;
  int32_T c51_i5;
  real_T c51_b_inData[2];
  int32_T c51_i6;
  real_T c51_u[2];
  const mxArray *c51_y = NULL;
  SFc51_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc51_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c51_mxArrayOutData = NULL;
  for (c51_i5 = 0; c51_i5 < 2; c51_i5++) {
    c51_b_inData[c51_i5] = (*(real_T (*)[2])c51_inData)[c51_i5];
  }

  for (c51_i6 = 0; c51_i6 < 2; c51_i6++) {
    c51_u[c51_i6] = c51_b_inData[c51_i6];
  }

  c51_y = NULL;
  sf_mex_assign(&c51_y, sf_mex_create("y", c51_u, 0, 0U, 1U, 0U, 1, 2));
  sf_mex_assign(&c51_mxArrayOutData, c51_y);
  return c51_mxArrayOutData;
}

static void c51_emlrt_marshallIn(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c51_xy_rot, const char_T *c51_identifier,
  real_T c51_y[2])
{
  emlrtMsgIdentifier c51_thisId;
  c51_thisId.fIdentifier = c51_identifier;
  c51_thisId.fParent = NULL;
  c51_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c51_xy_rot), &c51_thisId,
    c51_y);
  sf_mex_destroy(&c51_xy_rot);
}

static void c51_b_emlrt_marshallIn(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c51_u, const emlrtMsgIdentifier *c51_parentId,
  real_T c51_y[2])
{
  real_T c51_dv1[2];
  int32_T c51_i7;
  sf_mex_import(c51_parentId, sf_mex_dup(c51_u), c51_dv1, 1, 0, 0U, 1, 0U, 1, 2);
  for (c51_i7 = 0; c51_i7 < 2; c51_i7++) {
    c51_y[c51_i7] = c51_dv1[c51_i7];
  }

  sf_mex_destroy(&c51_u);
}

static void c51_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c51_mxArrayInData, const char_T *c51_varName, void *c51_outData)
{
  const mxArray *c51_xy_rot;
  const char_T *c51_identifier;
  emlrtMsgIdentifier c51_thisId;
  real_T c51_y[2];
  int32_T c51_i8;
  SFc51_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc51_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c51_xy_rot = sf_mex_dup(c51_mxArrayInData);
  c51_identifier = c51_varName;
  c51_thisId.fIdentifier = c51_identifier;
  c51_thisId.fParent = NULL;
  c51_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c51_xy_rot), &c51_thisId,
    c51_y);
  sf_mex_destroy(&c51_xy_rot);
  for (c51_i8 = 0; c51_i8 < 2; c51_i8++) {
    (*(real_T (*)[2])c51_outData)[c51_i8] = c51_y[c51_i8];
  }

  sf_mex_destroy(&c51_mxArrayInData);
}

static const mxArray *c51_b_sf_marshallOut(void *chartInstanceVoid, void
  *c51_inData)
{
  const mxArray *c51_mxArrayOutData = NULL;
  real_T c51_u;
  const mxArray *c51_y = NULL;
  SFc51_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc51_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c51_mxArrayOutData = NULL;
  c51_u = *(real_T *)c51_inData;
  c51_y = NULL;
  sf_mex_assign(&c51_y, sf_mex_create("y", &c51_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c51_mxArrayOutData, c51_y);
  return c51_mxArrayOutData;
}

static real_T c51_c_emlrt_marshallIn(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c51_u, const emlrtMsgIdentifier *c51_parentId)
{
  real_T c51_y;
  real_T c51_d0;
  sf_mex_import(c51_parentId, sf_mex_dup(c51_u), &c51_d0, 1, 0, 0U, 0, 0U, 0);
  c51_y = c51_d0;
  sf_mex_destroy(&c51_u);
  return c51_y;
}

static void c51_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c51_mxArrayInData, const char_T *c51_varName, void *c51_outData)
{
  const mxArray *c51_nargout;
  const char_T *c51_identifier;
  emlrtMsgIdentifier c51_thisId;
  real_T c51_y;
  SFc51_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc51_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c51_nargout = sf_mex_dup(c51_mxArrayInData);
  c51_identifier = c51_varName;
  c51_thisId.fIdentifier = c51_identifier;
  c51_thisId.fParent = NULL;
  c51_y = c51_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c51_nargout),
    &c51_thisId);
  sf_mex_destroy(&c51_nargout);
  *(real_T *)c51_outData = c51_y;
  sf_mex_destroy(&c51_mxArrayInData);
}

const mxArray *sf_c51_ACX_Simulator_get_eml_resolved_functions_info(void)
{
  const mxArray *c51_nameCaptureInfo;
  c51_ResolvedFunctionInfo c51_info[5];
  c51_ResolvedFunctionInfo (*c51_b_info)[5];
  const mxArray *c51_m0 = NULL;
  int32_T c51_i9;
  c51_ResolvedFunctionInfo *c51_r0;
  c51_nameCaptureInfo = NULL;
  c51_nameCaptureInfo = NULL;
  c51_b_info = (c51_ResolvedFunctionInfo (*)[5])c51_info;
  (*c51_b_info)[0].context = "";
  (*c51_b_info)[0].name = "cos";
  (*c51_b_info)[0].dominantType = "double";
  (*c51_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  (*c51_b_info)[0].fileTimeLo = 1286818706U;
  (*c51_b_info)[0].fileTimeHi = 0U;
  (*c51_b_info)[0].mFileTimeLo = 0U;
  (*c51_b_info)[0].mFileTimeHi = 0U;
  (*c51_b_info)[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  (*c51_b_info)[1].name = "eml_scalar_cos";
  (*c51_b_info)[1].dominantType = "double";
  (*c51_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  (*c51_b_info)[1].fileTimeLo = 1286818722U;
  (*c51_b_info)[1].fileTimeHi = 0U;
  (*c51_b_info)[1].mFileTimeLo = 0U;
  (*c51_b_info)[1].mFileTimeHi = 0U;
  (*c51_b_info)[2].context = "";
  (*c51_b_info)[2].name = "mtimes";
  (*c51_b_info)[2].dominantType = "double";
  (*c51_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c51_b_info)[2].fileTimeLo = 1289519692U;
  (*c51_b_info)[2].fileTimeHi = 0U;
  (*c51_b_info)[2].mFileTimeLo = 0U;
  (*c51_b_info)[2].mFileTimeHi = 0U;
  (*c51_b_info)[3].context = "";
  (*c51_b_info)[3].name = "sin";
  (*c51_b_info)[3].dominantType = "double";
  (*c51_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  (*c51_b_info)[3].fileTimeLo = 1286818750U;
  (*c51_b_info)[3].fileTimeHi = 0U;
  (*c51_b_info)[3].mFileTimeLo = 0U;
  (*c51_b_info)[3].mFileTimeHi = 0U;
  (*c51_b_info)[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  (*c51_b_info)[4].name = "eml_scalar_sin";
  (*c51_b_info)[4].dominantType = "double";
  (*c51_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  (*c51_b_info)[4].fileTimeLo = 1286818736U;
  (*c51_b_info)[4].fileTimeHi = 0U;
  (*c51_b_info)[4].mFileTimeLo = 0U;
  (*c51_b_info)[4].mFileTimeHi = 0U;
  sf_mex_assign(&c51_m0, sf_mex_createstruct("nameCaptureInfo", 1, 5));
  for (c51_i9 = 0; c51_i9 < 5; c51_i9++) {
    c51_r0 = &c51_info[c51_i9];
    sf_mex_addfield(c51_m0, sf_mex_create("nameCaptureInfo", c51_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c51_r0->context)), "context", "nameCaptureInfo",
                    c51_i9);
    sf_mex_addfield(c51_m0, sf_mex_create("nameCaptureInfo", c51_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c51_r0->name)), "name", "nameCaptureInfo", c51_i9);
    sf_mex_addfield(c51_m0, sf_mex_create("nameCaptureInfo",
      c51_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c51_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c51_i9);
    sf_mex_addfield(c51_m0, sf_mex_create("nameCaptureInfo", c51_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c51_r0->resolved)), "resolved",
                    "nameCaptureInfo", c51_i9);
    sf_mex_addfield(c51_m0, sf_mex_create("nameCaptureInfo", &c51_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c51_i9);
    sf_mex_addfield(c51_m0, sf_mex_create("nameCaptureInfo", &c51_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c51_i9);
    sf_mex_addfield(c51_m0, sf_mex_create("nameCaptureInfo",
      &c51_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c51_i9);
    sf_mex_addfield(c51_m0, sf_mex_create("nameCaptureInfo",
      &c51_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c51_i9);
  }

  sf_mex_assign(&c51_nameCaptureInfo, c51_m0);
  return c51_nameCaptureInfo;
}

static const mxArray *c51_c_sf_marshallOut(void *chartInstanceVoid, void
  *c51_inData)
{
  const mxArray *c51_mxArrayOutData = NULL;
  int32_T c51_u;
  const mxArray *c51_y = NULL;
  SFc51_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc51_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c51_mxArrayOutData = NULL;
  c51_u = *(int32_T *)c51_inData;
  c51_y = NULL;
  sf_mex_assign(&c51_y, sf_mex_create("y", &c51_u, 6, 0U, 0U, 0U, 0));
  sf_mex_assign(&c51_mxArrayOutData, c51_y);
  return c51_mxArrayOutData;
}

static int32_T c51_d_emlrt_marshallIn(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c51_u, const emlrtMsgIdentifier *c51_parentId)
{
  int32_T c51_y;
  int32_T c51_i10;
  sf_mex_import(c51_parentId, sf_mex_dup(c51_u), &c51_i10, 1, 6, 0U, 0, 0U, 0);
  c51_y = c51_i10;
  sf_mex_destroy(&c51_u);
  return c51_y;
}

static void c51_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c51_mxArrayInData, const char_T *c51_varName, void *c51_outData)
{
  const mxArray *c51_b_sfEvent;
  const char_T *c51_identifier;
  emlrtMsgIdentifier c51_thisId;
  int32_T c51_y;
  SFc51_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc51_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c51_b_sfEvent = sf_mex_dup(c51_mxArrayInData);
  c51_identifier = c51_varName;
  c51_thisId.fIdentifier = c51_identifier;
  c51_thisId.fParent = NULL;
  c51_y = c51_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c51_b_sfEvent),
    &c51_thisId);
  sf_mex_destroy(&c51_b_sfEvent);
  *(int32_T *)c51_outData = c51_y;
  sf_mex_destroy(&c51_mxArrayInData);
}

static uint8_T c51_e_emlrt_marshallIn(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c51_b_is_active_c51_ACX_Simulator, const char_T
  *c51_identifier)
{
  uint8_T c51_y;
  emlrtMsgIdentifier c51_thisId;
  c51_thisId.fIdentifier = c51_identifier;
  c51_thisId.fParent = NULL;
  c51_y = c51_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c51_b_is_active_c51_ACX_Simulator), &c51_thisId);
  sf_mex_destroy(&c51_b_is_active_c51_ACX_Simulator);
  return c51_y;
}

static uint8_T c51_f_emlrt_marshallIn(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c51_u, const emlrtMsgIdentifier *c51_parentId)
{
  uint8_T c51_y;
  uint8_T c51_u0;
  sf_mex_import(c51_parentId, sf_mex_dup(c51_u), &c51_u0, 1, 3, 0U, 0, 0U, 0);
  c51_y = c51_u0;
  sf_mex_destroy(&c51_u);
  return c51_y;
}

static void init_dsm_address_info(SFc51_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c51_ACX_Simulator_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3234132293U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2422532728U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2936657717U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(962786358U);
}

mxArray *sf_c51_ACX_Simulator_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3897219135U);
    pr[1] = (double)(129338184U);
    pr[2] = (double)(499602559U);
    pr[3] = (double)(4144134888U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c51_ACX_Simulator(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"xy_rot\",},{M[8],M[0],T\"is_active_c51_ACX_Simulator\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c51_ACX_Simulator_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc51_ACX_SimulatorInstanceStruct *chartInstance;
    chartInstance = (SFc51_ACX_SimulatorInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ACX_SimulatorMachineNumber_,
           51,
           1,
           1,
           4,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_ACX_SimulatorMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"x");
          _SFD_SET_DATA_PROPS(1,1,1,0,"y");
          _SFD_SET_DATA_PROPS(2,2,0,1,"xy_rot");
          _SFD_SET_DATA_PROPS(3,1,1,0,"heading");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,234);
        _SFD_CV_INIT_EML_IF(0,0,140,156,-1,184);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c51_b_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c51_b_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c51_sf_marshallOut,(MexInFcnForType)
            c51_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c51_b_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c51_x;
          real_T *c51_y;
          real_T *c51_heading;
          real_T (*c51_xy_rot)[2];
          c51_heading = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c51_xy_rot = (real_T (*)[2])ssGetOutputPortSignal(chartInstance->S, 1);
          c51_y = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c51_x = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c51_x);
          _SFD_SET_DATA_VALUE_PTR(1U, c51_y);
          _SFD_SET_DATA_VALUE_PTR(2U, *c51_xy_rot);
          _SFD_SET_DATA_VALUE_PTR(3U, c51_heading);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ACX_SimulatorMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c51_ACX_Simulator(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc51_ACX_SimulatorInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c51_ACX_Simulator((SFc51_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
  initialize_c51_ACX_Simulator((SFc51_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c51_ACX_Simulator(void *chartInstanceVar)
{
  enable_c51_ACX_Simulator((SFc51_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c51_ACX_Simulator(void *chartInstanceVar)
{
  disable_c51_ACX_Simulator((SFc51_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c51_ACX_Simulator(void *chartInstanceVar)
{
  sf_c51_ACX_Simulator((SFc51_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c51_ACX_Simulator(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c51_ACX_Simulator
    ((SFc51_ACX_SimulatorInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c51_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c51_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c51_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c51_ACX_Simulator((SFc51_ACX_SimulatorInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c51_ACX_Simulator(SimStruct* S)
{
  return sf_internal_get_sim_state_c51_ACX_Simulator(S);
}

static void sf_opaque_set_sim_state_c51_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c51_ACX_Simulator(S, st);
}

static void sf_opaque_terminate_c51_ACX_Simulator(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc51_ACX_SimulatorInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c51_ACX_Simulator((SFc51_ACX_SimulatorInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc51_ACX_Simulator((SFc51_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c51_ACX_Simulator(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c51_ACX_Simulator((SFc51_ACX_SimulatorInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c51_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,"ACX_Simulator","ACX_Simulator",51);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,"ACX_Simulator","ACX_Simulator",51,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,"ACX_Simulator",
      "ACX_Simulator",51,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"ACX_Simulator","ACX_Simulator",51,3);
      sf_mark_chart_reusable_outputs(S,"ACX_Simulator","ACX_Simulator",51,1);
    }

    sf_set_rtw_dwork_info(S,"ACX_Simulator","ACX_Simulator",51);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1078180639U));
  ssSetChecksum1(S,(969251148U));
  ssSetChecksum2(S,(1597203394U));
  ssSetChecksum3(S,(298313168U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c51_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "ACX_Simulator", "ACX_Simulator",51);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c51_ACX_Simulator(SimStruct *S)
{
  SFc51_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc51_ACX_SimulatorInstanceStruct *)malloc(sizeof
    (SFc51_ACX_SimulatorInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc51_ACX_SimulatorInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c51_ACX_Simulator;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c51_ACX_Simulator;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c51_ACX_Simulator;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c51_ACX_Simulator;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c51_ACX_Simulator;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c51_ACX_Simulator;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c51_ACX_Simulator;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c51_ACX_Simulator;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c51_ACX_Simulator;
  chartInstance->chartInfo.mdlStart = mdlStart_c51_ACX_Simulator;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c51_ACX_Simulator;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c51_ACX_Simulator_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c51_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c51_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c51_ACX_Simulator(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c51_ACX_Simulator_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
