#ifndef __c82_ACX_Simulator_h__
#define __c82_ACX_Simulator_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c82_ResolvedFunctionInfo;

typedef struct {
  SimStruct *S;
  int32_T c82_sfEvent;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  boolean_T c82_doneDoubleBufferReInit;
  boolean_T c82_isStable;
  uint8_T c82_is_active_c82_ACX_Simulator;
  ChartInfoStruct chartInfo;
} SFc82_ACX_SimulatorInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c82_ACX_Simulator_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c82_ACX_Simulator_get_check_sum(mxArray *plhs[]);
extern void c82_ACX_Simulator_method_dispatcher(SimStruct *S, int_T method, void
  *data);

#endif
