/* Include files */

#include "blascompat32.h"
#include "ACX_Simulator_sfun.h"
#include "c89_ACX_Simulator.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ACX_Simulator_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c89_debug_family_names[8] = { "nargin", "nargout", "phi_r",
  "theta_r", "DGRP", "DGPR", "phi_r_dc", "theta_r_dc" };

/* Function Declarations */
static void initialize_c89_ACX_Simulator(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initialize_params_c89_ACX_Simulator
  (SFc89_ACX_SimulatorInstanceStruct *chartInstance);
static void enable_c89_ACX_Simulator(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance);
static void disable_c89_ACX_Simulator(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance);
static void c89_update_debugger_state_c89_ACX_Simulator
  (SFc89_ACX_SimulatorInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c89_ACX_Simulator
  (SFc89_ACX_SimulatorInstanceStruct *chartInstance);
static void set_sim_state_c89_ACX_Simulator(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c89_st);
static void finalize_c89_ACX_Simulator(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance);
static void sf_c89_ACX_Simulator(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initSimStructsc89_ACX_Simulator(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c89_machineNumber, uint32_T
  c89_chartNumber);
static const mxArray *c89_sf_marshallOut(void *chartInstanceVoid, void
  *c89_inData);
static real_T c89_emlrt_marshallIn(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c89_theta_r_dc, const char_T *c89_identifier);
static real_T c89_b_emlrt_marshallIn(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c89_u, const emlrtMsgIdentifier *c89_parentId);
static void c89_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c89_mxArrayInData, const char_T *c89_varName, void *c89_outData);
static const mxArray *c89_b_sf_marshallOut(void *chartInstanceVoid, void
  *c89_inData);
static int32_T c89_c_emlrt_marshallIn(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c89_u, const emlrtMsgIdentifier *c89_parentId);
static void c89_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c89_mxArrayInData, const char_T *c89_varName, void *c89_outData);
static uint8_T c89_d_emlrt_marshallIn(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c89_b_is_active_c89_ACX_Simulator, const char_T
  *c89_identifier);
static uint8_T c89_e_emlrt_marshallIn(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c89_u, const emlrtMsgIdentifier *c89_parentId);
static void init_dsm_address_info(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c89_ACX_Simulator(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  chartInstance->c89_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c89_is_active_c89_ACX_Simulator = 0U;
}

static void initialize_params_c89_ACX_Simulator
  (SFc89_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static void enable_c89_ACX_Simulator(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c89_ACX_Simulator(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c89_update_debugger_state_c89_ACX_Simulator
  (SFc89_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c89_ACX_Simulator
  (SFc89_ACX_SimulatorInstanceStruct *chartInstance)
{
  const mxArray *c89_st;
  const mxArray *c89_y = NULL;
  real_T c89_hoistedGlobal;
  real_T c89_u;
  const mxArray *c89_b_y = NULL;
  real_T c89_b_hoistedGlobal;
  real_T c89_b_u;
  const mxArray *c89_c_y = NULL;
  uint8_T c89_c_hoistedGlobal;
  uint8_T c89_c_u;
  const mxArray *c89_d_y = NULL;
  real_T *c89_phi_r_dc;
  real_T *c89_theta_r_dc;
  c89_theta_r_dc = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c89_phi_r_dc = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c89_st = NULL;
  c89_st = NULL;
  c89_y = NULL;
  sf_mex_assign(&c89_y, sf_mex_createcellarray(3));
  c89_hoistedGlobal = *c89_phi_r_dc;
  c89_u = c89_hoistedGlobal;
  c89_b_y = NULL;
  sf_mex_assign(&c89_b_y, sf_mex_create("y", &c89_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c89_y, 0, c89_b_y);
  c89_b_hoistedGlobal = *c89_theta_r_dc;
  c89_b_u = c89_b_hoistedGlobal;
  c89_c_y = NULL;
  sf_mex_assign(&c89_c_y, sf_mex_create("y", &c89_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c89_y, 1, c89_c_y);
  c89_c_hoistedGlobal = chartInstance->c89_is_active_c89_ACX_Simulator;
  c89_c_u = c89_c_hoistedGlobal;
  c89_d_y = NULL;
  sf_mex_assign(&c89_d_y, sf_mex_create("y", &c89_c_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c89_y, 2, c89_d_y);
  sf_mex_assign(&c89_st, c89_y);
  return c89_st;
}

static void set_sim_state_c89_ACX_Simulator(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c89_st)
{
  const mxArray *c89_u;
  real_T *c89_phi_r_dc;
  real_T *c89_theta_r_dc;
  c89_theta_r_dc = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c89_phi_r_dc = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c89_doneDoubleBufferReInit = TRUE;
  c89_u = sf_mex_dup(c89_st);
  *c89_phi_r_dc = c89_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c89_u, 0)), "phi_r_dc");
  *c89_theta_r_dc = c89_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c89_u, 1)), "theta_r_dc");
  chartInstance->c89_is_active_c89_ACX_Simulator = c89_d_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c89_u, 2)),
     "is_active_c89_ACX_Simulator");
  sf_mex_destroy(&c89_u);
  c89_update_debugger_state_c89_ACX_Simulator(chartInstance);
  sf_mex_destroy(&c89_st);
}

static void finalize_c89_ACX_Simulator(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void sf_c89_ACX_Simulator(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  real_T c89_hoistedGlobal;
  real_T c89_b_hoistedGlobal;
  real_T c89_c_hoistedGlobal;
  real_T c89_d_hoistedGlobal;
  real_T c89_phi_r;
  real_T c89_theta_r;
  real_T c89_DGRP;
  real_T c89_DGPR;
  uint32_T c89_debug_family_var_map[8];
  real_T c89_nargin = 4.0;
  real_T c89_nargout = 2.0;
  real_T c89_phi_r_dc;
  real_T c89_theta_r_dc;
  real_T c89_a;
  real_T c89_b;
  real_T c89_y;
  real_T c89_b_a;
  real_T c89_b_b;
  real_T c89_b_y;
  real_T *c89_b_phi_r;
  real_T *c89_b_phi_r_dc;
  real_T *c89_b_theta_r;
  real_T *c89_b_DGRP;
  real_T *c89_b_theta_r_dc;
  real_T *c89_b_DGPR;
  c89_b_DGPR = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c89_b_theta_r_dc = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c89_b_DGRP = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c89_b_theta_r = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c89_b_phi_r_dc = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c89_b_phi_r = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 61U, chartInstance->c89_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c89_b_phi_r, 0U);
  _SFD_DATA_RANGE_CHECK(*c89_b_phi_r_dc, 1U);
  _SFD_DATA_RANGE_CHECK(*c89_b_theta_r, 2U);
  _SFD_DATA_RANGE_CHECK(*c89_b_DGRP, 3U);
  _SFD_DATA_RANGE_CHECK(*c89_b_theta_r_dc, 4U);
  _SFD_DATA_RANGE_CHECK(*c89_b_DGPR, 5U);
  chartInstance->c89_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 61U, chartInstance->c89_sfEvent);
  c89_hoistedGlobal = *c89_b_phi_r;
  c89_b_hoistedGlobal = *c89_b_theta_r;
  c89_c_hoistedGlobal = *c89_b_DGRP;
  c89_d_hoistedGlobal = *c89_b_DGPR;
  c89_phi_r = c89_hoistedGlobal;
  c89_theta_r = c89_b_hoistedGlobal;
  c89_DGRP = c89_c_hoistedGlobal;
  c89_DGPR = c89_d_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 8U, 8U, c89_debug_family_names,
    c89_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c89_nargin, 0U, c89_sf_marshallOut,
    c89_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c89_nargout, 1U, c89_sf_marshallOut,
    c89_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c89_phi_r, 2U, c89_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c89_theta_r, 3U, c89_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c89_DGRP, 4U, c89_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c89_DGPR, 5U, c89_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c89_phi_r_dc, 6U, c89_sf_marshallOut,
    c89_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c89_theta_r_dc, 7U,
    c89_sf_marshallOut, c89_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c89_sfEvent, 4);
  c89_a = c89_DGPR;
  c89_b = c89_theta_r;
  c89_y = c89_a * c89_b;
  c89_phi_r_dc = c89_phi_r + c89_y;
  _SFD_EML_CALL(0U, chartInstance->c89_sfEvent, 5);
  c89_b_a = c89_DGRP;
  c89_b_b = c89_phi_r;
  c89_b_y = c89_b_a * c89_b_b;
  c89_theta_r_dc = c89_theta_r - c89_b_y;
  _SFD_EML_CALL(0U, chartInstance->c89_sfEvent, -5);
  sf_debug_symbol_scope_pop();
  *c89_b_phi_r_dc = c89_phi_r_dc;
  *c89_b_theta_r_dc = c89_theta_r_dc;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 61U, chartInstance->c89_sfEvent);
  sf_debug_check_for_state_inconsistency(_ACX_SimulatorMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc89_ACX_Simulator(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c89_machineNumber, uint32_T
  c89_chartNumber)
{
}

static const mxArray *c89_sf_marshallOut(void *chartInstanceVoid, void
  *c89_inData)
{
  const mxArray *c89_mxArrayOutData = NULL;
  real_T c89_u;
  const mxArray *c89_y = NULL;
  SFc89_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc89_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c89_mxArrayOutData = NULL;
  c89_u = *(real_T *)c89_inData;
  c89_y = NULL;
  sf_mex_assign(&c89_y, sf_mex_create("y", &c89_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c89_mxArrayOutData, c89_y);
  return c89_mxArrayOutData;
}

static real_T c89_emlrt_marshallIn(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c89_theta_r_dc, const char_T *c89_identifier)
{
  real_T c89_y;
  emlrtMsgIdentifier c89_thisId;
  c89_thisId.fIdentifier = c89_identifier;
  c89_thisId.fParent = NULL;
  c89_y = c89_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c89_theta_r_dc),
    &c89_thisId);
  sf_mex_destroy(&c89_theta_r_dc);
  return c89_y;
}

static real_T c89_b_emlrt_marshallIn(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c89_u, const emlrtMsgIdentifier *c89_parentId)
{
  real_T c89_y;
  real_T c89_d0;
  sf_mex_import(c89_parentId, sf_mex_dup(c89_u), &c89_d0, 1, 0, 0U, 0, 0U, 0);
  c89_y = c89_d0;
  sf_mex_destroy(&c89_u);
  return c89_y;
}

static void c89_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c89_mxArrayInData, const char_T *c89_varName, void *c89_outData)
{
  const mxArray *c89_theta_r_dc;
  const char_T *c89_identifier;
  emlrtMsgIdentifier c89_thisId;
  real_T c89_y;
  SFc89_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc89_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c89_theta_r_dc = sf_mex_dup(c89_mxArrayInData);
  c89_identifier = c89_varName;
  c89_thisId.fIdentifier = c89_identifier;
  c89_thisId.fParent = NULL;
  c89_y = c89_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c89_theta_r_dc),
    &c89_thisId);
  sf_mex_destroy(&c89_theta_r_dc);
  *(real_T *)c89_outData = c89_y;
  sf_mex_destroy(&c89_mxArrayInData);
}

const mxArray *sf_c89_ACX_Simulator_get_eml_resolved_functions_info(void)
{
  const mxArray *c89_nameCaptureInfo;
  c89_ResolvedFunctionInfo c89_info[1];
  c89_ResolvedFunctionInfo (*c89_b_info)[1];
  const mxArray *c89_m0 = NULL;
  int32_T c89_i0;
  c89_ResolvedFunctionInfo *c89_r0;
  c89_nameCaptureInfo = NULL;
  c89_nameCaptureInfo = NULL;
  c89_b_info = (c89_ResolvedFunctionInfo (*)[1])c89_info;
  (*c89_b_info)[0].context = "";
  (*c89_b_info)[0].name = "mtimes";
  (*c89_b_info)[0].dominantType = "double";
  (*c89_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c89_b_info)[0].fileTimeLo = 1289519692U;
  (*c89_b_info)[0].fileTimeHi = 0U;
  (*c89_b_info)[0].mFileTimeLo = 0U;
  (*c89_b_info)[0].mFileTimeHi = 0U;
  sf_mex_assign(&c89_m0, sf_mex_createstruct("nameCaptureInfo", 1, 1));
  for (c89_i0 = 0; c89_i0 < 1; c89_i0++) {
    c89_r0 = &c89_info[c89_i0];
    sf_mex_addfield(c89_m0, sf_mex_create("nameCaptureInfo", c89_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c89_r0->context)), "context", "nameCaptureInfo",
                    c89_i0);
    sf_mex_addfield(c89_m0, sf_mex_create("nameCaptureInfo", c89_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c89_r0->name)), "name", "nameCaptureInfo", c89_i0);
    sf_mex_addfield(c89_m0, sf_mex_create("nameCaptureInfo",
      c89_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c89_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c89_i0);
    sf_mex_addfield(c89_m0, sf_mex_create("nameCaptureInfo", c89_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c89_r0->resolved)), "resolved",
                    "nameCaptureInfo", c89_i0);
    sf_mex_addfield(c89_m0, sf_mex_create("nameCaptureInfo", &c89_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c89_i0);
    sf_mex_addfield(c89_m0, sf_mex_create("nameCaptureInfo", &c89_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c89_i0);
    sf_mex_addfield(c89_m0, sf_mex_create("nameCaptureInfo",
      &c89_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c89_i0);
    sf_mex_addfield(c89_m0, sf_mex_create("nameCaptureInfo",
      &c89_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c89_i0);
  }

  sf_mex_assign(&c89_nameCaptureInfo, c89_m0);
  return c89_nameCaptureInfo;
}

static const mxArray *c89_b_sf_marshallOut(void *chartInstanceVoid, void
  *c89_inData)
{
  const mxArray *c89_mxArrayOutData = NULL;
  int32_T c89_u;
  const mxArray *c89_y = NULL;
  SFc89_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc89_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c89_mxArrayOutData = NULL;
  c89_u = *(int32_T *)c89_inData;
  c89_y = NULL;
  sf_mex_assign(&c89_y, sf_mex_create("y", &c89_u, 6, 0U, 0U, 0U, 0));
  sf_mex_assign(&c89_mxArrayOutData, c89_y);
  return c89_mxArrayOutData;
}

static int32_T c89_c_emlrt_marshallIn(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c89_u, const emlrtMsgIdentifier *c89_parentId)
{
  int32_T c89_y;
  int32_T c89_i1;
  sf_mex_import(c89_parentId, sf_mex_dup(c89_u), &c89_i1, 1, 6, 0U, 0, 0U, 0);
  c89_y = c89_i1;
  sf_mex_destroy(&c89_u);
  return c89_y;
}

static void c89_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c89_mxArrayInData, const char_T *c89_varName, void *c89_outData)
{
  const mxArray *c89_b_sfEvent;
  const char_T *c89_identifier;
  emlrtMsgIdentifier c89_thisId;
  int32_T c89_y;
  SFc89_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc89_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c89_b_sfEvent = sf_mex_dup(c89_mxArrayInData);
  c89_identifier = c89_varName;
  c89_thisId.fIdentifier = c89_identifier;
  c89_thisId.fParent = NULL;
  c89_y = c89_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c89_b_sfEvent),
    &c89_thisId);
  sf_mex_destroy(&c89_b_sfEvent);
  *(int32_T *)c89_outData = c89_y;
  sf_mex_destroy(&c89_mxArrayInData);
}

static uint8_T c89_d_emlrt_marshallIn(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c89_b_is_active_c89_ACX_Simulator, const char_T
  *c89_identifier)
{
  uint8_T c89_y;
  emlrtMsgIdentifier c89_thisId;
  c89_thisId.fIdentifier = c89_identifier;
  c89_thisId.fParent = NULL;
  c89_y = c89_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c89_b_is_active_c89_ACX_Simulator), &c89_thisId);
  sf_mex_destroy(&c89_b_is_active_c89_ACX_Simulator);
  return c89_y;
}

static uint8_T c89_e_emlrt_marshallIn(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c89_u, const emlrtMsgIdentifier *c89_parentId)
{
  uint8_T c89_y;
  uint8_T c89_u0;
  sf_mex_import(c89_parentId, sf_mex_dup(c89_u), &c89_u0, 1, 3, 0U, 0, 0U, 0);
  c89_y = c89_u0;
  sf_mex_destroy(&c89_u);
  return c89_y;
}

static void init_dsm_address_info(SFc89_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c89_ACX_Simulator_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1451485190U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1994816761U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3519670640U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3702546575U);
}

mxArray *sf_c89_ACX_Simulator_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2256562006U);
    pr[1] = (double)(2312369099U);
    pr[2] = (double)(4234136702U);
    pr[3] = (double)(2454090525U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c89_ACX_Simulator(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[5],T\"phi_r_dc\",},{M[1],M[8],T\"theta_r_dc\",},{M[8],M[0],T\"is_active_c89_ACX_Simulator\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c89_ACX_Simulator_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc89_ACX_SimulatorInstanceStruct *chartInstance;
    chartInstance = (SFc89_ACX_SimulatorInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ACX_SimulatorMachineNumber_,
           89,
           1,
           1,
           6,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_ACX_SimulatorMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"phi_r");
          _SFD_SET_DATA_PROPS(1,2,0,1,"phi_r_dc");
          _SFD_SET_DATA_PROPS(2,1,1,0,"theta_r");
          _SFD_SET_DATA_PROPS(3,1,1,0,"DGRP");
          _SFD_SET_DATA_PROPS(4,2,0,1,"theta_r_dc");
          _SFD_SET_DATA_PROPS(5,1,1,0,"DGPR");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,163);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c89_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c89_sf_marshallOut,(MexInFcnForType)c89_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c89_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c89_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c89_sf_marshallOut,(MexInFcnForType)c89_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c89_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c89_phi_r;
          real_T *c89_phi_r_dc;
          real_T *c89_theta_r;
          real_T *c89_DGRP;
          real_T *c89_theta_r_dc;
          real_T *c89_DGPR;
          c89_DGPR = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c89_theta_r_dc = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c89_DGRP = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c89_theta_r = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c89_phi_r_dc = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c89_phi_r = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c89_phi_r);
          _SFD_SET_DATA_VALUE_PTR(1U, c89_phi_r_dc);
          _SFD_SET_DATA_VALUE_PTR(2U, c89_theta_r);
          _SFD_SET_DATA_VALUE_PTR(3U, c89_DGRP);
          _SFD_SET_DATA_VALUE_PTR(4U, c89_theta_r_dc);
          _SFD_SET_DATA_VALUE_PTR(5U, c89_DGPR);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ACX_SimulatorMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c89_ACX_Simulator(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc89_ACX_SimulatorInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c89_ACX_Simulator((SFc89_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
  initialize_c89_ACX_Simulator((SFc89_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c89_ACX_Simulator(void *chartInstanceVar)
{
  enable_c89_ACX_Simulator((SFc89_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c89_ACX_Simulator(void *chartInstanceVar)
{
  disable_c89_ACX_Simulator((SFc89_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c89_ACX_Simulator(void *chartInstanceVar)
{
  sf_c89_ACX_Simulator((SFc89_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c89_ACX_Simulator(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c89_ACX_Simulator
    ((SFc89_ACX_SimulatorInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c89_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c89_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c89_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c89_ACX_Simulator((SFc89_ACX_SimulatorInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c89_ACX_Simulator(SimStruct* S)
{
  return sf_internal_get_sim_state_c89_ACX_Simulator(S);
}

static void sf_opaque_set_sim_state_c89_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c89_ACX_Simulator(S, st);
}

static void sf_opaque_terminate_c89_ACX_Simulator(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc89_ACX_SimulatorInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c89_ACX_Simulator((SFc89_ACX_SimulatorInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc89_ACX_Simulator((SFc89_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c89_ACX_Simulator(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c89_ACX_Simulator((SFc89_ACX_SimulatorInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c89_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,"ACX_Simulator","ACX_Simulator",89);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,"ACX_Simulator","ACX_Simulator",89,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,"ACX_Simulator",
      "ACX_Simulator",89,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"ACX_Simulator","ACX_Simulator",89,4);
      sf_mark_chart_reusable_outputs(S,"ACX_Simulator","ACX_Simulator",89,2);
    }

    sf_set_rtw_dwork_info(S,"ACX_Simulator","ACX_Simulator",89);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1137445574U));
  ssSetChecksum1(S,(2240706833U));
  ssSetChecksum2(S,(1829921896U));
  ssSetChecksum3(S,(4213811057U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c89_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "ACX_Simulator", "ACX_Simulator",89);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c89_ACX_Simulator(SimStruct *S)
{
  SFc89_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc89_ACX_SimulatorInstanceStruct *)malloc(sizeof
    (SFc89_ACX_SimulatorInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc89_ACX_SimulatorInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c89_ACX_Simulator;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c89_ACX_Simulator;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c89_ACX_Simulator;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c89_ACX_Simulator;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c89_ACX_Simulator;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c89_ACX_Simulator;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c89_ACX_Simulator;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c89_ACX_Simulator;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c89_ACX_Simulator;
  chartInstance->chartInfo.mdlStart = mdlStart_c89_ACX_Simulator;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c89_ACX_Simulator;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c89_ACX_Simulator_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c89_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c89_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c89_ACX_Simulator(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c89_ACX_Simulator_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
