function fit_val_2d = Traj_Fit(x_ref,y_ref,x_resp,y_resp)
%
%   Syntax: 
%   fit_val_2d = Traj_Fit(x_ref,y_ref,x_resp,y_resp)
%
%   Authors: Kostas Alexis (konstantinos.alexis@mavt.ethz.ch)
%
for i = 1:length(x_resp)
    distVector = sqrt((x_ref-x_resp(i)).^2 + (y_ref-y_resp(i)).^2);

    minDist(i) = min(distVector);
end

fit_val_2d = mean(minDist);

end