%%  CREATE STATE SPACE MODELS (FOR OLD MATLAB VERSIONS)

%%
MIMO_ATTI_SS = ss(A_mimo_atti_ss,B_mimo_atti_ss,C_mimo_atti_ss,D_mimo_atti_ss);
MIMO_ATTI_SS.InputName = InputsString;
MIMO_ATTI_SS.StateName = StatesString;
MIMO_ATTI_SS.OutputName = OutputsString;
MIMO_ATTI_SS.InputDelay = InputsDelay;

%%
MIMO_ATTI_SS_FO = ss(A_mimo_atti_ss_fo,B_mimo_atti_ss_fo,C_mimo_atti_ss_fo,D_mimo_atti_ss_fo);
MIMO_ATTI_SS_FO.InputName = InputsString_fo;
MIMO_ATTI_SS_FO.StateName = StatesString_fo;
MIMO_ATTI_SS_FO.OutputName = OutputsString_fo;
MIMO_ATTI_SS_FO.InputDelay = InputsDelay_fo;


%%

MIMO_RW_HO_SS = ss(A_mimo_rw_ho_ss,B_mimo_rw_ho_ss,C_mimo_rw_ho_ss,D_mimo_rw_ho_ss);
MIMO_RW_HO_SS.InputDelay = InputsDelay_rw_ho;
MIMO_RW_HO_SS.InputName = InputsString_rw_ho;
MIMO_RW_HO_SS.StateName = StatesString_rw_ho;
MIMO_RW_HO_SS.OutputName = OutputsString_rw_ho;


%%
VEL_CASC_ATTI_TF = tf(num_vel_casc_atti_tf,den_vel_casc_atti_tf);
%%

VEL_CASC_ATTI_SS = ss(A_matrix_vel_casc_atti_ss,B_matrix_vel_casc_atti_ss,C_matrix_vel_casc_atti_ss,D_matrix_vel_casc_atti_ss);
VEL_CASC_ATTI_SS.InputDelay = InputsDelay_vel_casc_atti_ss;
VEL_CASC_ATTI_SS.InputName = InputsString_vel_casc_atti_ss;
VEL_CASC_ATTI_SS.StateName = StatesString_vel_casc_atti_ss;
VEL_CASC_ATTI_SS.OutputName = OutputsString_vel_casc_ati_ss;

%%

MIMO_ATTI_SS_AUG_SMALL_INPUTS = ss(A_matrix_mimo_atti_ss_aug_small,B_matrix_mimo_atti_ss_aug_small,C_matrix_mimo_atti_ss_aug_small,D_matrix_mimo_atti_ss_aug_small);
MIMO_ATTI_SS_AUG_SMALL_INPUTS.InputDelay = InputsDelay_mimo_atti_ss_aug_small;
MIMO_ATTI_SS_AUG_SMALL_INPUTS.InputName = InputsString_mimo_atti_ss_aug_small;
MIMO_ATTI_SS_AUG_SMALL_INPUTS.StateName = StatesString_mimo_atti_ss_aug_small;
MIMO_ATTI_SS_AUG_SMALL_INPUTS.OutputName = OutputsString_mimo_atti_ss_aug_small;

%%

Ut_rpm = tf(Ut_rpm_num,Ut_rpm_den);

%%
r_miso_ss = ss(A_matrix_r_miso_ss,B_matrix_r_miso_ss,C_matrix_r_miso_ss,D_matrix_r_miso_ss);

%%

w_miso_ss = ss(A_matrix_w_miso_ss,B_matrix_w_miso_ss,C_matrix_w_miso_ss,D_matrix_w_miso_ss);

