function rad_s = Hz2rad_s(Hz)
%
%   syntax:
%    rad_s = Hz2rad_s(Hz)
%
%   Input:
%   Hz      : Revolutions per second
%    
%   Output:
%   rad_s   : radians per second
%
%
%   Authors:    Kostas Alexis (konstantinos.alexis@mavt.ethz.ch)

rad_s = Hz*(2*pi);
end