/* Include files */

#include "blascompat32.h"
#include "ACX_Simulator_sfun.h"
#include "c29_ACX_Simulator.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ACX_Simulator_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c29_debug_family_names[9] = { "numGains", "Switch_K_P",
  "nargin", "nargout", "EV", "GainNominal", "GainSched", "MaxDeltaEV", "Gain_S"
};

/* Function Declarations */
static void initialize_c29_ACX_Simulator(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initialize_params_c29_ACX_Simulator
  (SFc29_ACX_SimulatorInstanceStruct *chartInstance);
static void enable_c29_ACX_Simulator(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance);
static void disable_c29_ACX_Simulator(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance);
static void c29_update_debugger_state_c29_ACX_Simulator
  (SFc29_ACX_SimulatorInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c29_ACX_Simulator
  (SFc29_ACX_SimulatorInstanceStruct *chartInstance);
static void set_sim_state_c29_ACX_Simulator(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c29_st);
static void finalize_c29_ACX_Simulator(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance);
static void sf_c29_ACX_Simulator(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initSimStructsc29_ACX_Simulator(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c29_machineNumber, uint32_T
  c29_chartNumber);
static const mxArray *c29_sf_marshallOut(void *chartInstanceVoid, void
  *c29_inData);
static real_T c29_emlrt_marshallIn(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c29_Gain_S, const char_T *c29_identifier);
static real_T c29_b_emlrt_marshallIn(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c29_u, const emlrtMsgIdentifier *c29_parentId);
static void c29_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c29_mxArrayInData, const char_T *c29_varName, void *c29_outData);
static const mxArray *c29_b_sf_marshallOut(void *chartInstanceVoid, void
  *c29_inData);
static const mxArray *c29_c_sf_marshallOut(void *chartInstanceVoid, void
  *c29_inData);
static int32_T c29_c_emlrt_marshallIn(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c29_u, const emlrtMsgIdentifier *c29_parentId);
static void c29_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c29_mxArrayInData, const char_T *c29_varName, void *c29_outData);
static uint8_T c29_d_emlrt_marshallIn(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c29_b_is_active_c29_ACX_Simulator, const char_T
  *c29_identifier);
static uint8_T c29_e_emlrt_marshallIn(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c29_u, const emlrtMsgIdentifier *c29_parentId);
static void init_dsm_address_info(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c29_ACX_Simulator(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  chartInstance->c29_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c29_is_active_c29_ACX_Simulator = 0U;
}

static void initialize_params_c29_ACX_Simulator
  (SFc29_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static void enable_c29_ACX_Simulator(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c29_ACX_Simulator(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c29_update_debugger_state_c29_ACX_Simulator
  (SFc29_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c29_ACX_Simulator
  (SFc29_ACX_SimulatorInstanceStruct *chartInstance)
{
  const mxArray *c29_st;
  const mxArray *c29_y = NULL;
  real_T c29_hoistedGlobal;
  real_T c29_u;
  const mxArray *c29_b_y = NULL;
  uint8_T c29_b_hoistedGlobal;
  uint8_T c29_b_u;
  const mxArray *c29_c_y = NULL;
  real_T *c29_Gain_S;
  c29_Gain_S = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c29_st = NULL;
  c29_st = NULL;
  c29_y = NULL;
  sf_mex_assign(&c29_y, sf_mex_createcellarray(2));
  c29_hoistedGlobal = *c29_Gain_S;
  c29_u = c29_hoistedGlobal;
  c29_b_y = NULL;
  sf_mex_assign(&c29_b_y, sf_mex_create("y", &c29_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c29_y, 0, c29_b_y);
  c29_b_hoistedGlobal = chartInstance->c29_is_active_c29_ACX_Simulator;
  c29_b_u = c29_b_hoistedGlobal;
  c29_c_y = NULL;
  sf_mex_assign(&c29_c_y, sf_mex_create("y", &c29_b_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c29_y, 1, c29_c_y);
  sf_mex_assign(&c29_st, c29_y);
  return c29_st;
}

static void set_sim_state_c29_ACX_Simulator(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c29_st)
{
  const mxArray *c29_u;
  real_T *c29_Gain_S;
  c29_Gain_S = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c29_doneDoubleBufferReInit = TRUE;
  c29_u = sf_mex_dup(c29_st);
  *c29_Gain_S = c29_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c29_u, 0)), "Gain_S");
  chartInstance->c29_is_active_c29_ACX_Simulator = c29_d_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c29_u, 1)),
     "is_active_c29_ACX_Simulator");
  sf_mex_destroy(&c29_u);
  c29_update_debugger_state_c29_ACX_Simulator(chartInstance);
  sf_mex_destroy(&c29_st);
}

static void finalize_c29_ACX_Simulator(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void sf_c29_ACX_Simulator(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  int32_T c29_i0;
  real_T c29_hoistedGlobal;
  real_T c29_b_hoistedGlobal;
  real_T c29_c_hoistedGlobal;
  real_T c29_EV;
  real_T c29_GainNominal;
  int32_T c29_i1;
  real_T c29_GainSched[10];
  real_T c29_MaxDeltaEV;
  uint32_T c29_debug_family_var_map[9];
  real_T c29_numGains;
  real_T c29_Switch_K_P;
  real_T c29_nargin = 4.0;
  real_T c29_nargout = 1.0;
  real_T c29_Gain_S;
  real_T c29_x;
  real_T c29_b_x;
  real_T c29_y;
  real_T c29_a;
  real_T c29_b_y;
  real_T c29_A;
  real_T c29_B;
  real_T c29_c_x;
  real_T c29_c_y;
  real_T c29_d_x;
  real_T c29_d_y;
  real_T c29_e_x;
  real_T c29_e_y;
  real_T c29_f_y;
  real_T c29_f_x;
  real_T c29_g_x;
  real_T c29_h_x;
  real_T c29_i_x;
  real_T c29_g_y;
  real_T *c29_b_EV;
  real_T *c29_b_GainNominal;
  real_T *c29_b_Gain_S;
  real_T *c29_b_MaxDeltaEV;
  real_T (*c29_b_GainSched)[10];
  c29_b_MaxDeltaEV = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c29_b_GainSched = (real_T (*)[10])ssGetInputPortSignal(chartInstance->S, 2);
  c29_b_Gain_S = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c29_b_GainNominal = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c29_b_EV = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 28U, chartInstance->c29_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c29_b_EV, 0U);
  _SFD_DATA_RANGE_CHECK(*c29_b_GainNominal, 1U);
  _SFD_DATA_RANGE_CHECK(*c29_b_Gain_S, 2U);
  for (c29_i0 = 0; c29_i0 < 10; c29_i0++) {
    _SFD_DATA_RANGE_CHECK((*c29_b_GainSched)[c29_i0], 3U);
  }

  _SFD_DATA_RANGE_CHECK(*c29_b_MaxDeltaEV, 4U);
  chartInstance->c29_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 28U, chartInstance->c29_sfEvent);
  c29_hoistedGlobal = *c29_b_EV;
  c29_b_hoistedGlobal = *c29_b_GainNominal;
  c29_c_hoistedGlobal = *c29_b_MaxDeltaEV;
  c29_EV = c29_hoistedGlobal;
  c29_GainNominal = c29_b_hoistedGlobal;
  for (c29_i1 = 0; c29_i1 < 10; c29_i1++) {
    c29_GainSched[c29_i1] = (*c29_b_GainSched)[c29_i1];
  }

  c29_MaxDeltaEV = c29_c_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 9U, 9U, c29_debug_family_names,
    c29_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c29_numGains, 0U, c29_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c29_Switch_K_P, 1U,
    c29_sf_marshallOut, c29_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c29_nargin, 2U, c29_sf_marshallOut,
    c29_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c29_nargout, 3U, c29_sf_marshallOut,
    c29_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c29_EV, 4U, c29_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c29_GainNominal, 5U, c29_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c29_GainSched, 6U, c29_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c29_MaxDeltaEV, 7U, c29_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c29_Gain_S, 8U, c29_sf_marshallOut,
    c29_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c29_sfEvent, 4);
  c29_numGains = 10.0;
  _SFD_EML_CALL(0U, chartInstance->c29_sfEvent, 6);
  c29_x = c29_EV;
  c29_b_x = c29_x;
  c29_y = muDoubleScalarAbs(c29_b_x);
  c29_a = c29_y;
  c29_b_y = c29_a * 9.0;
  c29_A = c29_b_y;
  c29_B = c29_MaxDeltaEV;
  c29_c_x = c29_A;
  c29_c_y = c29_B;
  c29_d_x = c29_c_x;
  c29_d_y = c29_c_y;
  c29_e_x = c29_d_x;
  c29_e_y = c29_d_y;
  c29_f_y = c29_e_x / c29_e_y;
  c29_f_x = c29_f_y;
  c29_g_x = c29_f_x;
  c29_g_x = muDoubleScalarFloor(c29_g_x);
  c29_Switch_K_P = c29_g_x + 1.0;
  _SFD_EML_CALL(0U, chartInstance->c29_sfEvent, 8);
  if (CV_EML_IF(0, 0, c29_Switch_K_P >= 10.0)) {
    _SFD_EML_CALL(0U, chartInstance->c29_sfEvent, 9);
    c29_Switch_K_P = 10.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c29_sfEvent, 12);
  c29_Gain_S = c29_GainNominal;
  _SFD_EML_CALL(0U, chartInstance->c29_sfEvent, 13);
  c29_h_x = c29_EV;
  c29_i_x = c29_h_x;
  c29_g_y = muDoubleScalarAbs(c29_i_x);
  if (CV_EML_IF(0, 1, c29_g_y > 0.05)) {
    _SFD_EML_CALL(0U, chartInstance->c29_sfEvent, 14);
    c29_Gain_S = c29_GainNominal - c29_GainSched[_SFD_EML_ARRAY_BOUNDS_CHECK(
      "GainSched", (int32_T)_SFD_INTEGER_CHECK("Switch_K_P", c29_Switch_K_P), 1,
      10, 1, 0) - 1];
  }

  _SFD_EML_CALL(0U, chartInstance->c29_sfEvent, -14);
  sf_debug_symbol_scope_pop();
  *c29_b_Gain_S = c29_Gain_S;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 28U, chartInstance->c29_sfEvent);
  sf_debug_check_for_state_inconsistency(_ACX_SimulatorMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc29_ACX_Simulator(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c29_machineNumber, uint32_T
  c29_chartNumber)
{
}

static const mxArray *c29_sf_marshallOut(void *chartInstanceVoid, void
  *c29_inData)
{
  const mxArray *c29_mxArrayOutData = NULL;
  real_T c29_u;
  const mxArray *c29_y = NULL;
  SFc29_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc29_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c29_mxArrayOutData = NULL;
  c29_u = *(real_T *)c29_inData;
  c29_y = NULL;
  sf_mex_assign(&c29_y, sf_mex_create("y", &c29_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c29_mxArrayOutData, c29_y);
  return c29_mxArrayOutData;
}

static real_T c29_emlrt_marshallIn(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c29_Gain_S, const char_T *c29_identifier)
{
  real_T c29_y;
  emlrtMsgIdentifier c29_thisId;
  c29_thisId.fIdentifier = c29_identifier;
  c29_thisId.fParent = NULL;
  c29_y = c29_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c29_Gain_S),
    &c29_thisId);
  sf_mex_destroy(&c29_Gain_S);
  return c29_y;
}

static real_T c29_b_emlrt_marshallIn(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c29_u, const emlrtMsgIdentifier *c29_parentId)
{
  real_T c29_y;
  real_T c29_d0;
  sf_mex_import(c29_parentId, sf_mex_dup(c29_u), &c29_d0, 1, 0, 0U, 0, 0U, 0);
  c29_y = c29_d0;
  sf_mex_destroy(&c29_u);
  return c29_y;
}

static void c29_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c29_mxArrayInData, const char_T *c29_varName, void *c29_outData)
{
  const mxArray *c29_Gain_S;
  const char_T *c29_identifier;
  emlrtMsgIdentifier c29_thisId;
  real_T c29_y;
  SFc29_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc29_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c29_Gain_S = sf_mex_dup(c29_mxArrayInData);
  c29_identifier = c29_varName;
  c29_thisId.fIdentifier = c29_identifier;
  c29_thisId.fParent = NULL;
  c29_y = c29_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c29_Gain_S),
    &c29_thisId);
  sf_mex_destroy(&c29_Gain_S);
  *(real_T *)c29_outData = c29_y;
  sf_mex_destroy(&c29_mxArrayInData);
}

static const mxArray *c29_b_sf_marshallOut(void *chartInstanceVoid, void
  *c29_inData)
{
  const mxArray *c29_mxArrayOutData = NULL;
  int32_T c29_i2;
  real_T c29_b_inData[10];
  int32_T c29_i3;
  real_T c29_u[10];
  const mxArray *c29_y = NULL;
  SFc29_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc29_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c29_mxArrayOutData = NULL;
  for (c29_i2 = 0; c29_i2 < 10; c29_i2++) {
    c29_b_inData[c29_i2] = (*(real_T (*)[10])c29_inData)[c29_i2];
  }

  for (c29_i3 = 0; c29_i3 < 10; c29_i3++) {
    c29_u[c29_i3] = c29_b_inData[c29_i3];
  }

  c29_y = NULL;
  sf_mex_assign(&c29_y, sf_mex_create("y", c29_u, 0, 0U, 1U, 0U, 1, 10));
  sf_mex_assign(&c29_mxArrayOutData, c29_y);
  return c29_mxArrayOutData;
}

const mxArray *sf_c29_ACX_Simulator_get_eml_resolved_functions_info(void)
{
  const mxArray *c29_nameCaptureInfo;
  c29_ResolvedFunctionInfo c29_info[9];
  c29_ResolvedFunctionInfo (*c29_b_info)[9];
  const mxArray *c29_m0 = NULL;
  int32_T c29_i4;
  c29_ResolvedFunctionInfo *c29_r0;
  c29_nameCaptureInfo = NULL;
  c29_nameCaptureInfo = NULL;
  c29_b_info = (c29_ResolvedFunctionInfo (*)[9])c29_info;
  (*c29_b_info)[0].context = "";
  (*c29_b_info)[0].name = "length";
  (*c29_b_info)[0].dominantType = "double";
  (*c29_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  (*c29_b_info)[0].fileTimeLo = 1286818760U;
  (*c29_b_info)[0].fileTimeHi = 0U;
  (*c29_b_info)[0].mFileTimeLo = 0U;
  (*c29_b_info)[0].mFileTimeHi = 0U;
  (*c29_b_info)[1].context = "";
  (*c29_b_info)[1].name = "abs";
  (*c29_b_info)[1].dominantType = "double";
  (*c29_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c29_b_info)[1].fileTimeLo = 1286818694U;
  (*c29_b_info)[1].fileTimeHi = 0U;
  (*c29_b_info)[1].mFileTimeLo = 0U;
  (*c29_b_info)[1].mFileTimeHi = 0U;
  (*c29_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c29_b_info)[2].name = "eml_scalar_abs";
  (*c29_b_info)[2].dominantType = "double";
  (*c29_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  (*c29_b_info)[2].fileTimeLo = 1286818712U;
  (*c29_b_info)[2].fileTimeHi = 0U;
  (*c29_b_info)[2].mFileTimeLo = 0U;
  (*c29_b_info)[2].mFileTimeHi = 0U;
  (*c29_b_info)[3].context = "";
  (*c29_b_info)[3].name = "mtimes";
  (*c29_b_info)[3].dominantType = "double";
  (*c29_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c29_b_info)[3].fileTimeLo = 1289519692U;
  (*c29_b_info)[3].fileTimeHi = 0U;
  (*c29_b_info)[3].mFileTimeLo = 0U;
  (*c29_b_info)[3].mFileTimeHi = 0U;
  (*c29_b_info)[4].context = "";
  (*c29_b_info)[4].name = "mrdivide";
  (*c29_b_info)[4].dominantType = "double";
  (*c29_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c29_b_info)[4].fileTimeLo = 1296664654U;
  (*c29_b_info)[4].fileTimeHi = 0U;
  (*c29_b_info)[4].mFileTimeLo = 1289519692U;
  (*c29_b_info)[4].mFileTimeHi = 0U;
  (*c29_b_info)[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c29_b_info)[5].name = "rdivide";
  (*c29_b_info)[5].dominantType = "double";
  (*c29_b_info)[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c29_b_info)[5].fileTimeLo = 1286818844U;
  (*c29_b_info)[5].fileTimeHi = 0U;
  (*c29_b_info)[5].mFileTimeLo = 0U;
  (*c29_b_info)[5].mFileTimeHi = 0U;
  (*c29_b_info)[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c29_b_info)[6].name = "eml_div";
  (*c29_b_info)[6].dominantType = "double";
  (*c29_b_info)[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c29_b_info)[6].fileTimeLo = 1286818698U;
  (*c29_b_info)[6].fileTimeHi = 0U;
  (*c29_b_info)[6].mFileTimeLo = 0U;
  (*c29_b_info)[6].mFileTimeHi = 0U;
  (*c29_b_info)[7].context = "";
  (*c29_b_info)[7].name = "floor";
  (*c29_b_info)[7].dominantType = "double";
  (*c29_b_info)[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  (*c29_b_info)[7].fileTimeLo = 1286818742U;
  (*c29_b_info)[7].fileTimeHi = 0U;
  (*c29_b_info)[7].mFileTimeLo = 0U;
  (*c29_b_info)[7].mFileTimeHi = 0U;
  (*c29_b_info)[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  (*c29_b_info)[8].name = "eml_scalar_floor";
  (*c29_b_info)[8].dominantType = "double";
  (*c29_b_info)[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  (*c29_b_info)[8].fileTimeLo = 1286818726U;
  (*c29_b_info)[8].fileTimeHi = 0U;
  (*c29_b_info)[8].mFileTimeLo = 0U;
  (*c29_b_info)[8].mFileTimeHi = 0U;
  sf_mex_assign(&c29_m0, sf_mex_createstruct("nameCaptureInfo", 1, 9));
  for (c29_i4 = 0; c29_i4 < 9; c29_i4++) {
    c29_r0 = &c29_info[c29_i4];
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo", c29_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c29_r0->context)), "context", "nameCaptureInfo",
                    c29_i4);
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo", c29_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c29_r0->name)), "name", "nameCaptureInfo", c29_i4);
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo",
      c29_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c29_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c29_i4);
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo", c29_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c29_r0->resolved)), "resolved",
                    "nameCaptureInfo", c29_i4);
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo", &c29_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c29_i4);
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo", &c29_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c29_i4);
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo",
      &c29_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c29_i4);
    sf_mex_addfield(c29_m0, sf_mex_create("nameCaptureInfo",
      &c29_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c29_i4);
  }

  sf_mex_assign(&c29_nameCaptureInfo, c29_m0);
  return c29_nameCaptureInfo;
}

static const mxArray *c29_c_sf_marshallOut(void *chartInstanceVoid, void
  *c29_inData)
{
  const mxArray *c29_mxArrayOutData = NULL;
  int32_T c29_u;
  const mxArray *c29_y = NULL;
  SFc29_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc29_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c29_mxArrayOutData = NULL;
  c29_u = *(int32_T *)c29_inData;
  c29_y = NULL;
  sf_mex_assign(&c29_y, sf_mex_create("y", &c29_u, 6, 0U, 0U, 0U, 0));
  sf_mex_assign(&c29_mxArrayOutData, c29_y);
  return c29_mxArrayOutData;
}

static int32_T c29_c_emlrt_marshallIn(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c29_u, const emlrtMsgIdentifier *c29_parentId)
{
  int32_T c29_y;
  int32_T c29_i5;
  sf_mex_import(c29_parentId, sf_mex_dup(c29_u), &c29_i5, 1, 6, 0U, 0, 0U, 0);
  c29_y = c29_i5;
  sf_mex_destroy(&c29_u);
  return c29_y;
}

static void c29_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c29_mxArrayInData, const char_T *c29_varName, void *c29_outData)
{
  const mxArray *c29_b_sfEvent;
  const char_T *c29_identifier;
  emlrtMsgIdentifier c29_thisId;
  int32_T c29_y;
  SFc29_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc29_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c29_b_sfEvent = sf_mex_dup(c29_mxArrayInData);
  c29_identifier = c29_varName;
  c29_thisId.fIdentifier = c29_identifier;
  c29_thisId.fParent = NULL;
  c29_y = c29_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c29_b_sfEvent),
    &c29_thisId);
  sf_mex_destroy(&c29_b_sfEvent);
  *(int32_T *)c29_outData = c29_y;
  sf_mex_destroy(&c29_mxArrayInData);
}

static uint8_T c29_d_emlrt_marshallIn(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c29_b_is_active_c29_ACX_Simulator, const char_T
  *c29_identifier)
{
  uint8_T c29_y;
  emlrtMsgIdentifier c29_thisId;
  c29_thisId.fIdentifier = c29_identifier;
  c29_thisId.fParent = NULL;
  c29_y = c29_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c29_b_is_active_c29_ACX_Simulator), &c29_thisId);
  sf_mex_destroy(&c29_b_is_active_c29_ACX_Simulator);
  return c29_y;
}

static uint8_T c29_e_emlrt_marshallIn(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c29_u, const emlrtMsgIdentifier *c29_parentId)
{
  uint8_T c29_y;
  uint8_T c29_u0;
  sf_mex_import(c29_parentId, sf_mex_dup(c29_u), &c29_u0, 1, 3, 0U, 0, 0U, 0);
  c29_y = c29_u0;
  sf_mex_destroy(&c29_u);
  return c29_y;
}

static void init_dsm_address_info(SFc29_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c29_ACX_Simulator_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3093092028U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(498364954U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2676883524U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3958290498U);
}

mxArray *sf_c29_ACX_Simulator_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(4151895139U);
    pr[1] = (double)(3740262229U);
    pr[2] = (double)(973031798U);
    pr[3] = (double)(2871140149U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(10);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c29_ACX_Simulator(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"Gain_S\",},{M[8],M[0],T\"is_active_c29_ACX_Simulator\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c29_ACX_Simulator_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc29_ACX_SimulatorInstanceStruct *chartInstance;
    chartInstance = (SFc29_ACX_SimulatorInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ACX_SimulatorMachineNumber_,
           29,
           1,
           1,
           5,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_ACX_SimulatorMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"EV");
          _SFD_SET_DATA_PROPS(1,1,1,0,"GainNominal");
          _SFD_SET_DATA_PROPS(2,2,0,1,"Gain_S");
          _SFD_SET_DATA_PROPS(3,1,1,0,"GainSched");
          _SFD_SET_DATA_PROPS(4,1,1,0,"MaxDeltaEV");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,2,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,340);
        _SFD_CV_INIT_EML_IF(0,0,169,202,-1,242);
        _SFD_CV_INIT_EML_IF(0,1,266,282,-1,336);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c29_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c29_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c29_sf_marshallOut,(MexInFcnForType)c29_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 10;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c29_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c29_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c29_EV;
          real_T *c29_GainNominal;
          real_T *c29_Gain_S;
          real_T *c29_MaxDeltaEV;
          real_T (*c29_GainSched)[10];
          c29_MaxDeltaEV = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c29_GainSched = (real_T (*)[10])ssGetInputPortSignal(chartInstance->S,
            2);
          c29_Gain_S = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c29_GainNominal = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c29_EV = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c29_EV);
          _SFD_SET_DATA_VALUE_PTR(1U, c29_GainNominal);
          _SFD_SET_DATA_VALUE_PTR(2U, c29_Gain_S);
          _SFD_SET_DATA_VALUE_PTR(3U, *c29_GainSched);
          _SFD_SET_DATA_VALUE_PTR(4U, c29_MaxDeltaEV);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ACX_SimulatorMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c29_ACX_Simulator(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc29_ACX_SimulatorInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c29_ACX_Simulator((SFc29_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
  initialize_c29_ACX_Simulator((SFc29_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c29_ACX_Simulator(void *chartInstanceVar)
{
  enable_c29_ACX_Simulator((SFc29_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c29_ACX_Simulator(void *chartInstanceVar)
{
  disable_c29_ACX_Simulator((SFc29_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c29_ACX_Simulator(void *chartInstanceVar)
{
  sf_c29_ACX_Simulator((SFc29_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c29_ACX_Simulator(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c29_ACX_Simulator
    ((SFc29_ACX_SimulatorInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c29_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c29_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c29_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c29_ACX_Simulator((SFc29_ACX_SimulatorInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c29_ACX_Simulator(SimStruct* S)
{
  return sf_internal_get_sim_state_c29_ACX_Simulator(S);
}

static void sf_opaque_set_sim_state_c29_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c29_ACX_Simulator(S, st);
}

static void sf_opaque_terminate_c29_ACX_Simulator(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc29_ACX_SimulatorInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c29_ACX_Simulator((SFc29_ACX_SimulatorInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc29_ACX_Simulator((SFc29_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c29_ACX_Simulator(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c29_ACX_Simulator((SFc29_ACX_SimulatorInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c29_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,"ACX_Simulator","ACX_Simulator",29);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,"ACX_Simulator","ACX_Simulator",29,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,"ACX_Simulator",
      "ACX_Simulator",29,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"ACX_Simulator","ACX_Simulator",29,4);
      sf_mark_chart_reusable_outputs(S,"ACX_Simulator","ACX_Simulator",29,1);
    }

    sf_set_rtw_dwork_info(S,"ACX_Simulator","ACX_Simulator",29);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(3609429560U));
  ssSetChecksum1(S,(1222961038U));
  ssSetChecksum2(S,(3865916016U));
  ssSetChecksum3(S,(2754962252U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c29_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "ACX_Simulator", "ACX_Simulator",29);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c29_ACX_Simulator(SimStruct *S)
{
  SFc29_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc29_ACX_SimulatorInstanceStruct *)malloc(sizeof
    (SFc29_ACX_SimulatorInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc29_ACX_SimulatorInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c29_ACX_Simulator;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c29_ACX_Simulator;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c29_ACX_Simulator;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c29_ACX_Simulator;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c29_ACX_Simulator;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c29_ACX_Simulator;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c29_ACX_Simulator;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c29_ACX_Simulator;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c29_ACX_Simulator;
  chartInstance->chartInfo.mdlStart = mdlStart_c29_ACX_Simulator;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c29_ACX_Simulator;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c29_ACX_Simulator_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c29_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c29_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c29_ACX_Simulator(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c29_ACX_Simulator_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
