/* Include files */

#include "blascompat32.h"
#include "ACX_Simulator_sfun.h"
#include "c59_ACX_Simulator.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ACX_Simulator_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c59_debug_family_names[6] = { "nargin", "nargout",
  "phi_theta_p_q", "phi", "p", "phi_theta_p_q_out" };

/* Function Declarations */
static void initialize_c59_ACX_Simulator(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initialize_params_c59_ACX_Simulator
  (SFc59_ACX_SimulatorInstanceStruct *chartInstance);
static void enable_c59_ACX_Simulator(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance);
static void disable_c59_ACX_Simulator(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance);
static void c59_update_debugger_state_c59_ACX_Simulator
  (SFc59_ACX_SimulatorInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c59_ACX_Simulator
  (SFc59_ACX_SimulatorInstanceStruct *chartInstance);
static void set_sim_state_c59_ACX_Simulator(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c59_st);
static void finalize_c59_ACX_Simulator(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance);
static void sf_c59_ACX_Simulator(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initSimStructsc59_ACX_Simulator(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c59_machineNumber, uint32_T
  c59_chartNumber);
static const mxArray *c59_sf_marshallOut(void *chartInstanceVoid, void
  *c59_inData);
static void c59_emlrt_marshallIn(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c59_phi_theta_p_q_out, const char_T
  *c59_identifier, real_T c59_y[4]);
static void c59_b_emlrt_marshallIn(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c59_u, const emlrtMsgIdentifier *c59_parentId,
  real_T c59_y[4]);
static void c59_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c59_mxArrayInData, const char_T *c59_varName, void *c59_outData);
static const mxArray *c59_b_sf_marshallOut(void *chartInstanceVoid, void
  *c59_inData);
static real_T c59_c_emlrt_marshallIn(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c59_u, const emlrtMsgIdentifier *c59_parentId);
static void c59_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c59_mxArrayInData, const char_T *c59_varName, void *c59_outData);
static const mxArray *c59_c_sf_marshallOut(void *chartInstanceVoid, void
  *c59_inData);
static int32_T c59_d_emlrt_marshallIn(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c59_u, const emlrtMsgIdentifier *c59_parentId);
static void c59_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c59_mxArrayInData, const char_T *c59_varName, void *c59_outData);
static uint8_T c59_e_emlrt_marshallIn(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c59_b_is_active_c59_ACX_Simulator, const char_T
  *c59_identifier);
static uint8_T c59_f_emlrt_marshallIn(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c59_u, const emlrtMsgIdentifier *c59_parentId);
static void init_dsm_address_info(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c59_ACX_Simulator(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  chartInstance->c59_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c59_is_active_c59_ACX_Simulator = 0U;
}

static void initialize_params_c59_ACX_Simulator
  (SFc59_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static void enable_c59_ACX_Simulator(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c59_ACX_Simulator(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c59_update_debugger_state_c59_ACX_Simulator
  (SFc59_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c59_ACX_Simulator
  (SFc59_ACX_SimulatorInstanceStruct *chartInstance)
{
  const mxArray *c59_st;
  const mxArray *c59_y = NULL;
  int32_T c59_i0;
  real_T c59_u[4];
  const mxArray *c59_b_y = NULL;
  uint8_T c59_hoistedGlobal;
  uint8_T c59_b_u;
  const mxArray *c59_c_y = NULL;
  real_T (*c59_phi_theta_p_q_out)[4];
  c59_phi_theta_p_q_out = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S,
    1);
  c59_st = NULL;
  c59_st = NULL;
  c59_y = NULL;
  sf_mex_assign(&c59_y, sf_mex_createcellarray(2));
  for (c59_i0 = 0; c59_i0 < 4; c59_i0++) {
    c59_u[c59_i0] = (*c59_phi_theta_p_q_out)[c59_i0];
  }

  c59_b_y = NULL;
  sf_mex_assign(&c59_b_y, sf_mex_create("y", c59_u, 0, 0U, 1U, 0U, 1, 4));
  sf_mex_setcell(c59_y, 0, c59_b_y);
  c59_hoistedGlobal = chartInstance->c59_is_active_c59_ACX_Simulator;
  c59_b_u = c59_hoistedGlobal;
  c59_c_y = NULL;
  sf_mex_assign(&c59_c_y, sf_mex_create("y", &c59_b_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c59_y, 1, c59_c_y);
  sf_mex_assign(&c59_st, c59_y);
  return c59_st;
}

static void set_sim_state_c59_ACX_Simulator(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c59_st)
{
  const mxArray *c59_u;
  real_T c59_dv0[4];
  int32_T c59_i1;
  real_T (*c59_phi_theta_p_q_out)[4];
  c59_phi_theta_p_q_out = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S,
    1);
  chartInstance->c59_doneDoubleBufferReInit = TRUE;
  c59_u = sf_mex_dup(c59_st);
  c59_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c59_u, 0)),
                       "phi_theta_p_q_out", c59_dv0);
  for (c59_i1 = 0; c59_i1 < 4; c59_i1++) {
    (*c59_phi_theta_p_q_out)[c59_i1] = c59_dv0[c59_i1];
  }

  chartInstance->c59_is_active_c59_ACX_Simulator = c59_e_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c59_u, 1)),
     "is_active_c59_ACX_Simulator");
  sf_mex_destroy(&c59_u);
  c59_update_debugger_state_c59_ACX_Simulator(chartInstance);
  sf_mex_destroy(&c59_st);
}

static void finalize_c59_ACX_Simulator(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void sf_c59_ACX_Simulator(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  int32_T c59_i2;
  int32_T c59_i3;
  real_T c59_hoistedGlobal;
  real_T c59_b_hoistedGlobal;
  int32_T c59_i4;
  real_T c59_phi_theta_p_q[4];
  real_T c59_phi;
  real_T c59_p;
  uint32_T c59_debug_family_var_map[6];
  real_T c59_nargin = 3.0;
  real_T c59_nargout = 1.0;
  real_T c59_phi_theta_p_q_out[4];
  int32_T c59_i5;
  int32_T c59_i6;
  real_T *c59_b_phi;
  real_T *c59_b_p;
  real_T (*c59_b_phi_theta_p_q_out)[4];
  real_T (*c59_b_phi_theta_p_q)[4];
  c59_b_p = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c59_b_phi = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c59_b_phi_theta_p_q_out = (real_T (*)[4])ssGetOutputPortSignal
    (chartInstance->S, 1);
  c59_b_phi_theta_p_q = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 58U, chartInstance->c59_sfEvent);
  for (c59_i2 = 0; c59_i2 < 4; c59_i2++) {
    _SFD_DATA_RANGE_CHECK((*c59_b_phi_theta_p_q)[c59_i2], 0U);
  }

  for (c59_i3 = 0; c59_i3 < 4; c59_i3++) {
    _SFD_DATA_RANGE_CHECK((*c59_b_phi_theta_p_q_out)[c59_i3], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c59_b_phi, 2U);
  _SFD_DATA_RANGE_CHECK(*c59_b_p, 3U);
  chartInstance->c59_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 58U, chartInstance->c59_sfEvent);
  c59_hoistedGlobal = *c59_b_phi;
  c59_b_hoistedGlobal = *c59_b_p;
  for (c59_i4 = 0; c59_i4 < 4; c59_i4++) {
    c59_phi_theta_p_q[c59_i4] = (*c59_b_phi_theta_p_q)[c59_i4];
  }

  c59_phi = c59_hoistedGlobal;
  c59_p = c59_b_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 6U, 6U, c59_debug_family_names,
    c59_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c59_nargin, 0U, c59_b_sf_marshallOut,
    c59_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c59_nargout, 1U,
    c59_b_sf_marshallOut, c59_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c59_phi_theta_p_q, 2U, c59_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c59_phi, 3U, c59_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c59_p, 4U, c59_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c59_phi_theta_p_q_out, 5U,
    c59_sf_marshallOut, c59_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c59_sfEvent, 4);
  for (c59_i5 = 0; c59_i5 < 4; c59_i5++) {
    c59_phi_theta_p_q_out[c59_i5] = c59_phi_theta_p_q[c59_i5];
  }

  _SFD_EML_CALL(0U, chartInstance->c59_sfEvent, 5);
  c59_phi_theta_p_q_out[0] = c59_phi;
  _SFD_EML_CALL(0U, chartInstance->c59_sfEvent, 6);
  c59_phi_theta_p_q_out[2] = c59_p;
  _SFD_EML_CALL(0U, chartInstance->c59_sfEvent, -6);
  sf_debug_symbol_scope_pop();
  for (c59_i6 = 0; c59_i6 < 4; c59_i6++) {
    (*c59_b_phi_theta_p_q_out)[c59_i6] = c59_phi_theta_p_q_out[c59_i6];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 58U, chartInstance->c59_sfEvent);
  sf_debug_check_for_state_inconsistency(_ACX_SimulatorMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc59_ACX_Simulator(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c59_machineNumber, uint32_T
  c59_chartNumber)
{
}

static const mxArray *c59_sf_marshallOut(void *chartInstanceVoid, void
  *c59_inData)
{
  const mxArray *c59_mxArrayOutData = NULL;
  int32_T c59_i7;
  real_T c59_b_inData[4];
  int32_T c59_i8;
  real_T c59_u[4];
  const mxArray *c59_y = NULL;
  SFc59_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc59_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c59_mxArrayOutData = NULL;
  for (c59_i7 = 0; c59_i7 < 4; c59_i7++) {
    c59_b_inData[c59_i7] = (*(real_T (*)[4])c59_inData)[c59_i7];
  }

  for (c59_i8 = 0; c59_i8 < 4; c59_i8++) {
    c59_u[c59_i8] = c59_b_inData[c59_i8];
  }

  c59_y = NULL;
  sf_mex_assign(&c59_y, sf_mex_create("y", c59_u, 0, 0U, 1U, 0U, 1, 4));
  sf_mex_assign(&c59_mxArrayOutData, c59_y);
  return c59_mxArrayOutData;
}

static void c59_emlrt_marshallIn(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c59_phi_theta_p_q_out, const char_T
  *c59_identifier, real_T c59_y[4])
{
  emlrtMsgIdentifier c59_thisId;
  c59_thisId.fIdentifier = c59_identifier;
  c59_thisId.fParent = NULL;
  c59_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c59_phi_theta_p_q_out),
    &c59_thisId, c59_y);
  sf_mex_destroy(&c59_phi_theta_p_q_out);
}

static void c59_b_emlrt_marshallIn(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c59_u, const emlrtMsgIdentifier *c59_parentId,
  real_T c59_y[4])
{
  real_T c59_dv1[4];
  int32_T c59_i9;
  sf_mex_import(c59_parentId, sf_mex_dup(c59_u), c59_dv1, 1, 0, 0U, 1, 0U, 1, 4);
  for (c59_i9 = 0; c59_i9 < 4; c59_i9++) {
    c59_y[c59_i9] = c59_dv1[c59_i9];
  }

  sf_mex_destroy(&c59_u);
}

static void c59_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c59_mxArrayInData, const char_T *c59_varName, void *c59_outData)
{
  const mxArray *c59_phi_theta_p_q_out;
  const char_T *c59_identifier;
  emlrtMsgIdentifier c59_thisId;
  real_T c59_y[4];
  int32_T c59_i10;
  SFc59_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc59_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c59_phi_theta_p_q_out = sf_mex_dup(c59_mxArrayInData);
  c59_identifier = c59_varName;
  c59_thisId.fIdentifier = c59_identifier;
  c59_thisId.fParent = NULL;
  c59_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c59_phi_theta_p_q_out),
    &c59_thisId, c59_y);
  sf_mex_destroy(&c59_phi_theta_p_q_out);
  for (c59_i10 = 0; c59_i10 < 4; c59_i10++) {
    (*(real_T (*)[4])c59_outData)[c59_i10] = c59_y[c59_i10];
  }

  sf_mex_destroy(&c59_mxArrayInData);
}

static const mxArray *c59_b_sf_marshallOut(void *chartInstanceVoid, void
  *c59_inData)
{
  const mxArray *c59_mxArrayOutData = NULL;
  real_T c59_u;
  const mxArray *c59_y = NULL;
  SFc59_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc59_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c59_mxArrayOutData = NULL;
  c59_u = *(real_T *)c59_inData;
  c59_y = NULL;
  sf_mex_assign(&c59_y, sf_mex_create("y", &c59_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c59_mxArrayOutData, c59_y);
  return c59_mxArrayOutData;
}

static real_T c59_c_emlrt_marshallIn(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c59_u, const emlrtMsgIdentifier *c59_parentId)
{
  real_T c59_y;
  real_T c59_d0;
  sf_mex_import(c59_parentId, sf_mex_dup(c59_u), &c59_d0, 1, 0, 0U, 0, 0U, 0);
  c59_y = c59_d0;
  sf_mex_destroy(&c59_u);
  return c59_y;
}

static void c59_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c59_mxArrayInData, const char_T *c59_varName, void *c59_outData)
{
  const mxArray *c59_nargout;
  const char_T *c59_identifier;
  emlrtMsgIdentifier c59_thisId;
  real_T c59_y;
  SFc59_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc59_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c59_nargout = sf_mex_dup(c59_mxArrayInData);
  c59_identifier = c59_varName;
  c59_thisId.fIdentifier = c59_identifier;
  c59_thisId.fParent = NULL;
  c59_y = c59_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c59_nargout),
    &c59_thisId);
  sf_mex_destroy(&c59_nargout);
  *(real_T *)c59_outData = c59_y;
  sf_mex_destroy(&c59_mxArrayInData);
}

const mxArray *sf_c59_ACX_Simulator_get_eml_resolved_functions_info(void)
{
  const mxArray *c59_nameCaptureInfo = NULL;
  c59_nameCaptureInfo = NULL;
  sf_mex_assign(&c59_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1));
  return c59_nameCaptureInfo;
}

static const mxArray *c59_c_sf_marshallOut(void *chartInstanceVoid, void
  *c59_inData)
{
  const mxArray *c59_mxArrayOutData = NULL;
  int32_T c59_u;
  const mxArray *c59_y = NULL;
  SFc59_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc59_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c59_mxArrayOutData = NULL;
  c59_u = *(int32_T *)c59_inData;
  c59_y = NULL;
  sf_mex_assign(&c59_y, sf_mex_create("y", &c59_u, 6, 0U, 0U, 0U, 0));
  sf_mex_assign(&c59_mxArrayOutData, c59_y);
  return c59_mxArrayOutData;
}

static int32_T c59_d_emlrt_marshallIn(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c59_u, const emlrtMsgIdentifier *c59_parentId)
{
  int32_T c59_y;
  int32_T c59_i11;
  sf_mex_import(c59_parentId, sf_mex_dup(c59_u), &c59_i11, 1, 6, 0U, 0, 0U, 0);
  c59_y = c59_i11;
  sf_mex_destroy(&c59_u);
  return c59_y;
}

static void c59_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c59_mxArrayInData, const char_T *c59_varName, void *c59_outData)
{
  const mxArray *c59_b_sfEvent;
  const char_T *c59_identifier;
  emlrtMsgIdentifier c59_thisId;
  int32_T c59_y;
  SFc59_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc59_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c59_b_sfEvent = sf_mex_dup(c59_mxArrayInData);
  c59_identifier = c59_varName;
  c59_thisId.fIdentifier = c59_identifier;
  c59_thisId.fParent = NULL;
  c59_y = c59_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c59_b_sfEvent),
    &c59_thisId);
  sf_mex_destroy(&c59_b_sfEvent);
  *(int32_T *)c59_outData = c59_y;
  sf_mex_destroy(&c59_mxArrayInData);
}

static uint8_T c59_e_emlrt_marshallIn(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c59_b_is_active_c59_ACX_Simulator, const char_T
  *c59_identifier)
{
  uint8_T c59_y;
  emlrtMsgIdentifier c59_thisId;
  c59_thisId.fIdentifier = c59_identifier;
  c59_thisId.fParent = NULL;
  c59_y = c59_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c59_b_is_active_c59_ACX_Simulator), &c59_thisId);
  sf_mex_destroy(&c59_b_is_active_c59_ACX_Simulator);
  return c59_y;
}

static uint8_T c59_f_emlrt_marshallIn(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c59_u, const emlrtMsgIdentifier *c59_parentId)
{
  uint8_T c59_y;
  uint8_T c59_u0;
  sf_mex_import(c59_parentId, sf_mex_dup(c59_u), &c59_u0, 1, 3, 0U, 0, 0U, 0);
  c59_y = c59_u0;
  sf_mex_destroy(&c59_u);
  return c59_y;
}

static void init_dsm_address_info(SFc59_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c59_ACX_Simulator_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(53997559U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(386962825U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3418087652U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1427886830U);
}

mxArray *sf_c59_ACX_Simulator_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2230321615U);
    pr[1] = (double)(2987037835U);
    pr[2] = (double)(3307360895U);
    pr[3] = (double)(2748878646U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c59_ACX_Simulator(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"phi_theta_p_q_out\",},{M[8],M[0],T\"is_active_c59_ACX_Simulator\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c59_ACX_Simulator_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc59_ACX_SimulatorInstanceStruct *chartInstance;
    chartInstance = (SFc59_ACX_SimulatorInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ACX_SimulatorMachineNumber_,
           59,
           1,
           1,
           4,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_ACX_SimulatorMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"phi_theta_p_q");
          _SFD_SET_DATA_PROPS(1,2,0,1,"phi_theta_p_q_out");
          _SFD_SET_DATA_PROPS(2,1,1,0,"phi");
          _SFD_SET_DATA_PROPS(3,1,1,0,"p");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,177);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c59_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c59_sf_marshallOut,(MexInFcnForType)
            c59_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c59_b_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c59_b_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c59_phi;
          real_T *c59_p;
          real_T (*c59_phi_theta_p_q)[4];
          real_T (*c59_phi_theta_p_q_out)[4];
          c59_p = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c59_phi = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c59_phi_theta_p_q_out = (real_T (*)[4])ssGetOutputPortSignal
            (chartInstance->S, 1);
          c59_phi_theta_p_q = (real_T (*)[4])ssGetInputPortSignal
            (chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c59_phi_theta_p_q);
          _SFD_SET_DATA_VALUE_PTR(1U, *c59_phi_theta_p_q_out);
          _SFD_SET_DATA_VALUE_PTR(2U, c59_phi);
          _SFD_SET_DATA_VALUE_PTR(3U, c59_p);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ACX_SimulatorMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c59_ACX_Simulator(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc59_ACX_SimulatorInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c59_ACX_Simulator((SFc59_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
  initialize_c59_ACX_Simulator((SFc59_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c59_ACX_Simulator(void *chartInstanceVar)
{
  enable_c59_ACX_Simulator((SFc59_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c59_ACX_Simulator(void *chartInstanceVar)
{
  disable_c59_ACX_Simulator((SFc59_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c59_ACX_Simulator(void *chartInstanceVar)
{
  sf_c59_ACX_Simulator((SFc59_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c59_ACX_Simulator(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c59_ACX_Simulator
    ((SFc59_ACX_SimulatorInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c59_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c59_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c59_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c59_ACX_Simulator((SFc59_ACX_SimulatorInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c59_ACX_Simulator(SimStruct* S)
{
  return sf_internal_get_sim_state_c59_ACX_Simulator(S);
}

static void sf_opaque_set_sim_state_c59_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c59_ACX_Simulator(S, st);
}

static void sf_opaque_terminate_c59_ACX_Simulator(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc59_ACX_SimulatorInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c59_ACX_Simulator((SFc59_ACX_SimulatorInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc59_ACX_Simulator((SFc59_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c59_ACX_Simulator(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c59_ACX_Simulator((SFc59_ACX_SimulatorInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c59_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,"ACX_Simulator","ACX_Simulator",59);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,"ACX_Simulator","ACX_Simulator",59,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,"ACX_Simulator",
      "ACX_Simulator",59,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"ACX_Simulator","ACX_Simulator",59,3);
      sf_mark_chart_reusable_outputs(S,"ACX_Simulator","ACX_Simulator",59,1);
    }

    sf_set_rtw_dwork_info(S,"ACX_Simulator","ACX_Simulator",59);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1338020628U));
  ssSetChecksum1(S,(2186002097U));
  ssSetChecksum2(S,(110657209U));
  ssSetChecksum3(S,(530755802U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c59_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "ACX_Simulator", "ACX_Simulator",59);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c59_ACX_Simulator(SimStruct *S)
{
  SFc59_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc59_ACX_SimulatorInstanceStruct *)malloc(sizeof
    (SFc59_ACX_SimulatorInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc59_ACX_SimulatorInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c59_ACX_Simulator;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c59_ACX_Simulator;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c59_ACX_Simulator;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c59_ACX_Simulator;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c59_ACX_Simulator;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c59_ACX_Simulator;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c59_ACX_Simulator;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c59_ACX_Simulator;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c59_ACX_Simulator;
  chartInstance->chartInfo.mdlStart = mdlStart_c59_ACX_Simulator;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c59_ACX_Simulator;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c59_ACX_Simulator_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c59_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c59_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c59_ACX_Simulator(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c59_ACX_Simulator_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
