/* Include files */

#include "blascompat32.h"
#include "ACX_Simulator_sfun.h"
#include "c84_ACX_Simulator.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ACX_Simulator_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c84_debug_family_names[8] = { "numGains", "Switch_K_P",
  "nargin", "nargout", "EV", "K_P_GS", "MaxDeltaEV", "Gain_S" };

/* Function Declarations */
static void initialize_c84_ACX_Simulator(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initialize_params_c84_ACX_Simulator
  (SFc84_ACX_SimulatorInstanceStruct *chartInstance);
static void enable_c84_ACX_Simulator(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance);
static void disable_c84_ACX_Simulator(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance);
static void c84_update_debugger_state_c84_ACX_Simulator
  (SFc84_ACX_SimulatorInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c84_ACX_Simulator
  (SFc84_ACX_SimulatorInstanceStruct *chartInstance);
static void set_sim_state_c84_ACX_Simulator(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c84_st);
static void finalize_c84_ACX_Simulator(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance);
static void sf_c84_ACX_Simulator(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initSimStructsc84_ACX_Simulator(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c84_machineNumber, uint32_T
  c84_chartNumber);
static const mxArray *c84_sf_marshallOut(void *chartInstanceVoid, void
  *c84_inData);
static real_T c84_emlrt_marshallIn(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c84_Gain_S, const char_T *c84_identifier);
static real_T c84_b_emlrt_marshallIn(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c84_u, const emlrtMsgIdentifier *c84_parentId);
static void c84_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c84_mxArrayInData, const char_T *c84_varName, void *c84_outData);
static const mxArray *c84_b_sf_marshallOut(void *chartInstanceVoid, void
  *c84_inData);
static const mxArray *c84_c_sf_marshallOut(void *chartInstanceVoid, void
  *c84_inData);
static int32_T c84_c_emlrt_marshallIn(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c84_u, const emlrtMsgIdentifier *c84_parentId);
static void c84_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c84_mxArrayInData, const char_T *c84_varName, void *c84_outData);
static uint8_T c84_d_emlrt_marshallIn(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c84_b_is_active_c84_ACX_Simulator, const char_T
  *c84_identifier);
static uint8_T c84_e_emlrt_marshallIn(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c84_u, const emlrtMsgIdentifier *c84_parentId);
static void init_dsm_address_info(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c84_ACX_Simulator(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  chartInstance->c84_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c84_is_active_c84_ACX_Simulator = 0U;
}

static void initialize_params_c84_ACX_Simulator
  (SFc84_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static void enable_c84_ACX_Simulator(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c84_ACX_Simulator(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c84_update_debugger_state_c84_ACX_Simulator
  (SFc84_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c84_ACX_Simulator
  (SFc84_ACX_SimulatorInstanceStruct *chartInstance)
{
  const mxArray *c84_st;
  const mxArray *c84_y = NULL;
  real_T c84_hoistedGlobal;
  real_T c84_u;
  const mxArray *c84_b_y = NULL;
  uint8_T c84_b_hoistedGlobal;
  uint8_T c84_b_u;
  const mxArray *c84_c_y = NULL;
  real_T *c84_Gain_S;
  c84_Gain_S = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c84_st = NULL;
  c84_st = NULL;
  c84_y = NULL;
  sf_mex_assign(&c84_y, sf_mex_createcellarray(2));
  c84_hoistedGlobal = *c84_Gain_S;
  c84_u = c84_hoistedGlobal;
  c84_b_y = NULL;
  sf_mex_assign(&c84_b_y, sf_mex_create("y", &c84_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c84_y, 0, c84_b_y);
  c84_b_hoistedGlobal = chartInstance->c84_is_active_c84_ACX_Simulator;
  c84_b_u = c84_b_hoistedGlobal;
  c84_c_y = NULL;
  sf_mex_assign(&c84_c_y, sf_mex_create("y", &c84_b_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c84_y, 1, c84_c_y);
  sf_mex_assign(&c84_st, c84_y);
  return c84_st;
}

static void set_sim_state_c84_ACX_Simulator(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c84_st)
{
  const mxArray *c84_u;
  real_T *c84_Gain_S;
  c84_Gain_S = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c84_doneDoubleBufferReInit = TRUE;
  c84_u = sf_mex_dup(c84_st);
  *c84_Gain_S = c84_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c84_u, 0)), "Gain_S");
  chartInstance->c84_is_active_c84_ACX_Simulator = c84_d_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c84_u, 1)),
     "is_active_c84_ACX_Simulator");
  sf_mex_destroy(&c84_u);
  c84_update_debugger_state_c84_ACX_Simulator(chartInstance);
  sf_mex_destroy(&c84_st);
}

static void finalize_c84_ACX_Simulator(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void sf_c84_ACX_Simulator(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  int32_T c84_i0;
  real_T c84_hoistedGlobal;
  real_T c84_b_hoistedGlobal;
  real_T c84_EV;
  int32_T c84_i1;
  real_T c84_K_P_GS[51];
  real_T c84_MaxDeltaEV;
  uint32_T c84_debug_family_var_map[8];
  real_T c84_numGains;
  real_T c84_Switch_K_P;
  real_T c84_nargin = 3.0;
  real_T c84_nargout = 1.0;
  real_T c84_Gain_S;
  real_T c84_x;
  real_T c84_b_x;
  real_T c84_y;
  real_T c84_a;
  real_T c84_b_y;
  real_T c84_A;
  real_T c84_B;
  real_T c84_c_x;
  real_T c84_c_y;
  real_T c84_d_x;
  real_T c84_d_y;
  real_T c84_e_x;
  real_T c84_e_y;
  real_T c84_f_y;
  real_T c84_f_x;
  real_T c84_g_x;
  real_T *c84_b_EV;
  real_T *c84_b_Gain_S;
  real_T *c84_b_MaxDeltaEV;
  real_T (*c84_b_K_P_GS)[51];
  c84_b_MaxDeltaEV = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c84_b_Gain_S = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c84_b_K_P_GS = (real_T (*)[51])ssGetInputPortSignal(chartInstance->S, 1);
  c84_b_EV = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 57U, chartInstance->c84_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c84_b_EV, 0U);
  for (c84_i0 = 0; c84_i0 < 51; c84_i0++) {
    _SFD_DATA_RANGE_CHECK((*c84_b_K_P_GS)[c84_i0], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c84_b_Gain_S, 2U);
  _SFD_DATA_RANGE_CHECK(*c84_b_MaxDeltaEV, 3U);
  chartInstance->c84_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 57U, chartInstance->c84_sfEvent);
  c84_hoistedGlobal = *c84_b_EV;
  c84_b_hoistedGlobal = *c84_b_MaxDeltaEV;
  c84_EV = c84_hoistedGlobal;
  for (c84_i1 = 0; c84_i1 < 51; c84_i1++) {
    c84_K_P_GS[c84_i1] = (*c84_b_K_P_GS)[c84_i1];
  }

  c84_MaxDeltaEV = c84_b_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 8U, 8U, c84_debug_family_names,
    c84_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c84_numGains, 0U, c84_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c84_Switch_K_P, 1U,
    c84_sf_marshallOut, c84_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c84_nargin, 2U, c84_sf_marshallOut,
    c84_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c84_nargout, 3U, c84_sf_marshallOut,
    c84_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c84_EV, 4U, c84_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c84_K_P_GS, 5U, c84_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c84_MaxDeltaEV, 6U, c84_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c84_Gain_S, 7U, c84_sf_marshallOut,
    c84_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c84_sfEvent, 4);
  c84_numGains = 51.0;
  _SFD_EML_CALL(0U, chartInstance->c84_sfEvent, 6);
  c84_x = c84_EV;
  c84_b_x = c84_x;
  c84_y = muDoubleScalarAbs(c84_b_x);
  c84_a = c84_y;
  c84_b_y = c84_a * 50.0;
  c84_A = c84_b_y;
  c84_B = c84_MaxDeltaEV;
  c84_c_x = c84_A;
  c84_c_y = c84_B;
  c84_d_x = c84_c_x;
  c84_d_y = c84_c_y;
  c84_e_x = c84_d_x;
  c84_e_y = c84_d_y;
  c84_f_y = c84_e_x / c84_e_y;
  c84_f_x = c84_f_y;
  c84_g_x = c84_f_x;
  c84_g_x = muDoubleScalarFloor(c84_g_x);
  c84_Switch_K_P = c84_g_x + 1.0;
  _SFD_EML_CALL(0U, chartInstance->c84_sfEvent, 8);
  if (CV_EML_IF(0, 0, c84_Switch_K_P >= 51.0)) {
    _SFD_EML_CALL(0U, chartInstance->c84_sfEvent, 9);
    c84_Switch_K_P = 51.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c84_sfEvent, 14);
  c84_Gain_S = c84_K_P_GS[_SFD_EML_ARRAY_BOUNDS_CHECK("K_P_GS", (int32_T)
    _SFD_INTEGER_CHECK("Switch_K_P", c84_Switch_K_P), 1, 51, 1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c84_sfEvent, -14);
  sf_debug_symbol_scope_pop();
  *c84_b_Gain_S = c84_Gain_S;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 57U, chartInstance->c84_sfEvent);
  sf_debug_check_for_state_inconsistency(_ACX_SimulatorMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc84_ACX_Simulator(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c84_machineNumber, uint32_T
  c84_chartNumber)
{
}

static const mxArray *c84_sf_marshallOut(void *chartInstanceVoid, void
  *c84_inData)
{
  const mxArray *c84_mxArrayOutData = NULL;
  real_T c84_u;
  const mxArray *c84_y = NULL;
  SFc84_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc84_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c84_mxArrayOutData = NULL;
  c84_u = *(real_T *)c84_inData;
  c84_y = NULL;
  sf_mex_assign(&c84_y, sf_mex_create("y", &c84_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c84_mxArrayOutData, c84_y);
  return c84_mxArrayOutData;
}

static real_T c84_emlrt_marshallIn(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c84_Gain_S, const char_T *c84_identifier)
{
  real_T c84_y;
  emlrtMsgIdentifier c84_thisId;
  c84_thisId.fIdentifier = c84_identifier;
  c84_thisId.fParent = NULL;
  c84_y = c84_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c84_Gain_S),
    &c84_thisId);
  sf_mex_destroy(&c84_Gain_S);
  return c84_y;
}

static real_T c84_b_emlrt_marshallIn(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c84_u, const emlrtMsgIdentifier *c84_parentId)
{
  real_T c84_y;
  real_T c84_d0;
  sf_mex_import(c84_parentId, sf_mex_dup(c84_u), &c84_d0, 1, 0, 0U, 0, 0U, 0);
  c84_y = c84_d0;
  sf_mex_destroy(&c84_u);
  return c84_y;
}

static void c84_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c84_mxArrayInData, const char_T *c84_varName, void *c84_outData)
{
  const mxArray *c84_Gain_S;
  const char_T *c84_identifier;
  emlrtMsgIdentifier c84_thisId;
  real_T c84_y;
  SFc84_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc84_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c84_Gain_S = sf_mex_dup(c84_mxArrayInData);
  c84_identifier = c84_varName;
  c84_thisId.fIdentifier = c84_identifier;
  c84_thisId.fParent = NULL;
  c84_y = c84_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c84_Gain_S),
    &c84_thisId);
  sf_mex_destroy(&c84_Gain_S);
  *(real_T *)c84_outData = c84_y;
  sf_mex_destroy(&c84_mxArrayInData);
}

static const mxArray *c84_b_sf_marshallOut(void *chartInstanceVoid, void
  *c84_inData)
{
  const mxArray *c84_mxArrayOutData = NULL;
  int32_T c84_i2;
  real_T c84_b_inData[51];
  int32_T c84_i3;
  real_T c84_u[51];
  const mxArray *c84_y = NULL;
  SFc84_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc84_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c84_mxArrayOutData = NULL;
  for (c84_i2 = 0; c84_i2 < 51; c84_i2++) {
    c84_b_inData[c84_i2] = (*(real_T (*)[51])c84_inData)[c84_i2];
  }

  for (c84_i3 = 0; c84_i3 < 51; c84_i3++) {
    c84_u[c84_i3] = c84_b_inData[c84_i3];
  }

  c84_y = NULL;
  sf_mex_assign(&c84_y, sf_mex_create("y", c84_u, 0, 0U, 1U, 0U, 1, 51));
  sf_mex_assign(&c84_mxArrayOutData, c84_y);
  return c84_mxArrayOutData;
}

const mxArray *sf_c84_ACX_Simulator_get_eml_resolved_functions_info(void)
{
  const mxArray *c84_nameCaptureInfo;
  c84_ResolvedFunctionInfo c84_info[9];
  c84_ResolvedFunctionInfo (*c84_b_info)[9];
  const mxArray *c84_m0 = NULL;
  int32_T c84_i4;
  c84_ResolvedFunctionInfo *c84_r0;
  c84_nameCaptureInfo = NULL;
  c84_nameCaptureInfo = NULL;
  c84_b_info = (c84_ResolvedFunctionInfo (*)[9])c84_info;
  (*c84_b_info)[0].context = "";
  (*c84_b_info)[0].name = "length";
  (*c84_b_info)[0].dominantType = "double";
  (*c84_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  (*c84_b_info)[0].fileTimeLo = 1286818760U;
  (*c84_b_info)[0].fileTimeHi = 0U;
  (*c84_b_info)[0].mFileTimeLo = 0U;
  (*c84_b_info)[0].mFileTimeHi = 0U;
  (*c84_b_info)[1].context = "";
  (*c84_b_info)[1].name = "abs";
  (*c84_b_info)[1].dominantType = "double";
  (*c84_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c84_b_info)[1].fileTimeLo = 1286818694U;
  (*c84_b_info)[1].fileTimeHi = 0U;
  (*c84_b_info)[1].mFileTimeLo = 0U;
  (*c84_b_info)[1].mFileTimeHi = 0U;
  (*c84_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c84_b_info)[2].name = "eml_scalar_abs";
  (*c84_b_info)[2].dominantType = "double";
  (*c84_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  (*c84_b_info)[2].fileTimeLo = 1286818712U;
  (*c84_b_info)[2].fileTimeHi = 0U;
  (*c84_b_info)[2].mFileTimeLo = 0U;
  (*c84_b_info)[2].mFileTimeHi = 0U;
  (*c84_b_info)[3].context = "";
  (*c84_b_info)[3].name = "mtimes";
  (*c84_b_info)[3].dominantType = "double";
  (*c84_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c84_b_info)[3].fileTimeLo = 1289519692U;
  (*c84_b_info)[3].fileTimeHi = 0U;
  (*c84_b_info)[3].mFileTimeLo = 0U;
  (*c84_b_info)[3].mFileTimeHi = 0U;
  (*c84_b_info)[4].context = "";
  (*c84_b_info)[4].name = "mrdivide";
  (*c84_b_info)[4].dominantType = "double";
  (*c84_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c84_b_info)[4].fileTimeLo = 1296664654U;
  (*c84_b_info)[4].fileTimeHi = 0U;
  (*c84_b_info)[4].mFileTimeLo = 1289519692U;
  (*c84_b_info)[4].mFileTimeHi = 0U;
  (*c84_b_info)[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c84_b_info)[5].name = "rdivide";
  (*c84_b_info)[5].dominantType = "double";
  (*c84_b_info)[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c84_b_info)[5].fileTimeLo = 1286818844U;
  (*c84_b_info)[5].fileTimeHi = 0U;
  (*c84_b_info)[5].mFileTimeLo = 0U;
  (*c84_b_info)[5].mFileTimeHi = 0U;
  (*c84_b_info)[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c84_b_info)[6].name = "eml_div";
  (*c84_b_info)[6].dominantType = "double";
  (*c84_b_info)[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c84_b_info)[6].fileTimeLo = 1286818698U;
  (*c84_b_info)[6].fileTimeHi = 0U;
  (*c84_b_info)[6].mFileTimeLo = 0U;
  (*c84_b_info)[6].mFileTimeHi = 0U;
  (*c84_b_info)[7].context = "";
  (*c84_b_info)[7].name = "floor";
  (*c84_b_info)[7].dominantType = "double";
  (*c84_b_info)[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  (*c84_b_info)[7].fileTimeLo = 1286818742U;
  (*c84_b_info)[7].fileTimeHi = 0U;
  (*c84_b_info)[7].mFileTimeLo = 0U;
  (*c84_b_info)[7].mFileTimeHi = 0U;
  (*c84_b_info)[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  (*c84_b_info)[8].name = "eml_scalar_floor";
  (*c84_b_info)[8].dominantType = "double";
  (*c84_b_info)[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  (*c84_b_info)[8].fileTimeLo = 1286818726U;
  (*c84_b_info)[8].fileTimeHi = 0U;
  (*c84_b_info)[8].mFileTimeLo = 0U;
  (*c84_b_info)[8].mFileTimeHi = 0U;
  sf_mex_assign(&c84_m0, sf_mex_createstruct("nameCaptureInfo", 1, 9));
  for (c84_i4 = 0; c84_i4 < 9; c84_i4++) {
    c84_r0 = &c84_info[c84_i4];
    sf_mex_addfield(c84_m0, sf_mex_create("nameCaptureInfo", c84_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c84_r0->context)), "context", "nameCaptureInfo",
                    c84_i4);
    sf_mex_addfield(c84_m0, sf_mex_create("nameCaptureInfo", c84_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c84_r0->name)), "name", "nameCaptureInfo", c84_i4);
    sf_mex_addfield(c84_m0, sf_mex_create("nameCaptureInfo",
      c84_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c84_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c84_i4);
    sf_mex_addfield(c84_m0, sf_mex_create("nameCaptureInfo", c84_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c84_r0->resolved)), "resolved",
                    "nameCaptureInfo", c84_i4);
    sf_mex_addfield(c84_m0, sf_mex_create("nameCaptureInfo", &c84_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c84_i4);
    sf_mex_addfield(c84_m0, sf_mex_create("nameCaptureInfo", &c84_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c84_i4);
    sf_mex_addfield(c84_m0, sf_mex_create("nameCaptureInfo",
      &c84_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c84_i4);
    sf_mex_addfield(c84_m0, sf_mex_create("nameCaptureInfo",
      &c84_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c84_i4);
  }

  sf_mex_assign(&c84_nameCaptureInfo, c84_m0);
  return c84_nameCaptureInfo;
}

static const mxArray *c84_c_sf_marshallOut(void *chartInstanceVoid, void
  *c84_inData)
{
  const mxArray *c84_mxArrayOutData = NULL;
  int32_T c84_u;
  const mxArray *c84_y = NULL;
  SFc84_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc84_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c84_mxArrayOutData = NULL;
  c84_u = *(int32_T *)c84_inData;
  c84_y = NULL;
  sf_mex_assign(&c84_y, sf_mex_create("y", &c84_u, 6, 0U, 0U, 0U, 0));
  sf_mex_assign(&c84_mxArrayOutData, c84_y);
  return c84_mxArrayOutData;
}

static int32_T c84_c_emlrt_marshallIn(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c84_u, const emlrtMsgIdentifier *c84_parentId)
{
  int32_T c84_y;
  int32_T c84_i5;
  sf_mex_import(c84_parentId, sf_mex_dup(c84_u), &c84_i5, 1, 6, 0U, 0, 0U, 0);
  c84_y = c84_i5;
  sf_mex_destroy(&c84_u);
  return c84_y;
}

static void c84_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c84_mxArrayInData, const char_T *c84_varName, void *c84_outData)
{
  const mxArray *c84_b_sfEvent;
  const char_T *c84_identifier;
  emlrtMsgIdentifier c84_thisId;
  int32_T c84_y;
  SFc84_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc84_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c84_b_sfEvent = sf_mex_dup(c84_mxArrayInData);
  c84_identifier = c84_varName;
  c84_thisId.fIdentifier = c84_identifier;
  c84_thisId.fParent = NULL;
  c84_y = c84_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c84_b_sfEvent),
    &c84_thisId);
  sf_mex_destroy(&c84_b_sfEvent);
  *(int32_T *)c84_outData = c84_y;
  sf_mex_destroy(&c84_mxArrayInData);
}

static uint8_T c84_d_emlrt_marshallIn(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c84_b_is_active_c84_ACX_Simulator, const char_T
  *c84_identifier)
{
  uint8_T c84_y;
  emlrtMsgIdentifier c84_thisId;
  c84_thisId.fIdentifier = c84_identifier;
  c84_thisId.fParent = NULL;
  c84_y = c84_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c84_b_is_active_c84_ACX_Simulator), &c84_thisId);
  sf_mex_destroy(&c84_b_is_active_c84_ACX_Simulator);
  return c84_y;
}

static uint8_T c84_e_emlrt_marshallIn(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c84_u, const emlrtMsgIdentifier *c84_parentId)
{
  uint8_T c84_y;
  uint8_T c84_u0;
  sf_mex_import(c84_parentId, sf_mex_dup(c84_u), &c84_u0, 1, 3, 0U, 0, 0U, 0);
  c84_y = c84_u0;
  sf_mex_destroy(&c84_u);
  return c84_y;
}

static void init_dsm_address_info(SFc84_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c84_ACX_Simulator_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1879769317U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2668936995U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(142671502U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2347092309U);
}

mxArray *sf_c84_ACX_Simulator_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3605838252U);
    pr[1] = (double)(3506839512U);
    pr[2] = (double)(4180178661U);
    pr[3] = (double)(1044117754U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(51);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c84_ACX_Simulator(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"Gain_S\",},{M[8],M[0],T\"is_active_c84_ACX_Simulator\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c84_ACX_Simulator_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc84_ACX_SimulatorInstanceStruct *chartInstance;
    chartInstance = (SFc84_ACX_SimulatorInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ACX_SimulatorMachineNumber_,
           84,
           1,
           1,
           4,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_ACX_SimulatorMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"EV");
          _SFD_SET_DATA_PROPS(1,1,1,0,"K_P_GS");
          _SFD_SET_DATA_PROPS(2,2,0,1,"Gain_S");
          _SFD_SET_DATA_PROPS(3,1,1,0,"MaxDeltaEV");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,232);
        _SFD_CV_INIT_EML_IF(0,0,151,169,-1,194);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c84_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 51;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c84_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c84_sf_marshallOut,(MexInFcnForType)c84_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c84_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c84_EV;
          real_T *c84_Gain_S;
          real_T *c84_MaxDeltaEV;
          real_T (*c84_K_P_GS)[51];
          c84_MaxDeltaEV = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c84_Gain_S = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c84_K_P_GS = (real_T (*)[51])ssGetInputPortSignal(chartInstance->S, 1);
          c84_EV = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c84_EV);
          _SFD_SET_DATA_VALUE_PTR(1U, *c84_K_P_GS);
          _SFD_SET_DATA_VALUE_PTR(2U, c84_Gain_S);
          _SFD_SET_DATA_VALUE_PTR(3U, c84_MaxDeltaEV);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ACX_SimulatorMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c84_ACX_Simulator(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc84_ACX_SimulatorInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c84_ACX_Simulator((SFc84_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
  initialize_c84_ACX_Simulator((SFc84_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c84_ACX_Simulator(void *chartInstanceVar)
{
  enable_c84_ACX_Simulator((SFc84_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c84_ACX_Simulator(void *chartInstanceVar)
{
  disable_c84_ACX_Simulator((SFc84_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c84_ACX_Simulator(void *chartInstanceVar)
{
  sf_c84_ACX_Simulator((SFc84_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c84_ACX_Simulator(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c84_ACX_Simulator
    ((SFc84_ACX_SimulatorInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c84_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c84_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c84_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c84_ACX_Simulator((SFc84_ACX_SimulatorInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c84_ACX_Simulator(SimStruct* S)
{
  return sf_internal_get_sim_state_c84_ACX_Simulator(S);
}

static void sf_opaque_set_sim_state_c84_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c84_ACX_Simulator(S, st);
}

static void sf_opaque_terminate_c84_ACX_Simulator(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc84_ACX_SimulatorInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c84_ACX_Simulator((SFc84_ACX_SimulatorInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc84_ACX_Simulator((SFc84_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c84_ACX_Simulator(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c84_ACX_Simulator((SFc84_ACX_SimulatorInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c84_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,"ACX_Simulator","ACX_Simulator",84);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,"ACX_Simulator","ACX_Simulator",84,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,"ACX_Simulator",
      "ACX_Simulator",84,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"ACX_Simulator","ACX_Simulator",84,3);
      sf_mark_chart_reusable_outputs(S,"ACX_Simulator","ACX_Simulator",84,1);
    }

    sf_set_rtw_dwork_info(S,"ACX_Simulator","ACX_Simulator",84);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(966872103U));
  ssSetChecksum1(S,(2528961419U));
  ssSetChecksum2(S,(1190560602U));
  ssSetChecksum3(S,(327215876U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c84_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "ACX_Simulator", "ACX_Simulator",84);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c84_ACX_Simulator(SimStruct *S)
{
  SFc84_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc84_ACX_SimulatorInstanceStruct *)malloc(sizeof
    (SFc84_ACX_SimulatorInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc84_ACX_SimulatorInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c84_ACX_Simulator;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c84_ACX_Simulator;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c84_ACX_Simulator;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c84_ACX_Simulator;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c84_ACX_Simulator;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c84_ACX_Simulator;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c84_ACX_Simulator;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c84_ACX_Simulator;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c84_ACX_Simulator;
  chartInstance->chartInfo.mdlStart = mdlStart_c84_ACX_Simulator;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c84_ACX_Simulator;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c84_ACX_Simulator_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c84_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c84_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c84_ACX_Simulator(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c84_ACX_Simulator_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
