#ifndef __c84_ACX_Simulator_h__
#define __c84_ACX_Simulator_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c84_ResolvedFunctionInfo;

typedef struct {
  SimStruct *S;
  int32_T c84_sfEvent;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  boolean_T c84_doneDoubleBufferReInit;
  boolean_T c84_isStable;
  uint8_T c84_is_active_c84_ACX_Simulator;
  ChartInfoStruct chartInfo;
} SFc84_ACX_SimulatorInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c84_ACX_Simulator_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c84_ACX_Simulator_get_check_sum(mxArray *plhs[]);
extern void c84_ACX_Simulator_method_dispatcher(SimStruct *S, int_T method, void
  *data);

#endif
